// Code generated by ent, DO NOT EDIT.

package label

import (
	"time"
	"wechat-api/ent/predicate"

	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
)

// ID filters vertices based on their ID field.
func ID(id uint64) predicate.Label {
	return predicate.Label(sql.FieldEQ(FieldID, id))
}

// IDEQ applies the EQ predicate on the ID field.
func IDEQ(id uint64) predicate.Label {
	return predicate.Label(sql.FieldEQ(FieldID, id))
}

// IDNEQ applies the NEQ predicate on the ID field.
func IDNEQ(id uint64) predicate.Label {
	return predicate.Label(sql.FieldNEQ(FieldID, id))
}

// IDIn applies the In predicate on the ID field.
func IDIn(ids ...uint64) predicate.Label {
	return predicate.Label(sql.FieldIn(FieldID, ids...))
}

// IDNotIn applies the NotIn predicate on the ID field.
func IDNotIn(ids ...uint64) predicate.Label {
	return predicate.Label(sql.FieldNotIn(FieldID, ids...))
}

// IDGT applies the GT predicate on the ID field.
func IDGT(id uint64) predicate.Label {
	return predicate.Label(sql.FieldGT(FieldID, id))
}

// IDGTE applies the GTE predicate on the ID field.
func IDGTE(id uint64) predicate.Label {
	return predicate.Label(sql.FieldGTE(FieldID, id))
}

// IDLT applies the LT predicate on the ID field.
func IDLT(id uint64) predicate.Label {
	return predicate.Label(sql.FieldLT(FieldID, id))
}

// IDLTE applies the LTE predicate on the ID field.
func IDLTE(id uint64) predicate.Label {
	return predicate.Label(sql.FieldLTE(FieldID, id))
}

// CreatedAt applies equality check predicate on the "created_at" field. It's identical to CreatedAtEQ.
func CreatedAt(v time.Time) predicate.Label {
	return predicate.Label(sql.FieldEQ(FieldCreatedAt, v))
}

// UpdatedAt applies equality check predicate on the "updated_at" field. It's identical to UpdatedAtEQ.
func UpdatedAt(v time.Time) predicate.Label {
	return predicate.Label(sql.FieldEQ(FieldUpdatedAt, v))
}

// Status applies equality check predicate on the "status" field. It's identical to StatusEQ.
func Status(v uint8) predicate.Label {
	return predicate.Label(sql.FieldEQ(FieldStatus, v))
}

// DeletedAt applies equality check predicate on the "deleted_at" field. It's identical to DeletedAtEQ.
func DeletedAt(v time.Time) predicate.Label {
	return predicate.Label(sql.FieldEQ(FieldDeletedAt, v))
}

// Type applies equality check predicate on the "type" field. It's identical to TypeEQ.
func Type(v int) predicate.Label {
	return predicate.Label(sql.FieldEQ(FieldType, v))
}

// Name applies equality check predicate on the "name" field. It's identical to NameEQ.
func Name(v string) predicate.Label {
	return predicate.Label(sql.FieldEQ(FieldName, v))
}

// From applies equality check predicate on the "from" field. It's identical to FromEQ.
func From(v int) predicate.Label {
	return predicate.Label(sql.FieldEQ(FieldFrom, v))
}

// Mode applies equality check predicate on the "mode" field. It's identical to ModeEQ.
func Mode(v int) predicate.Label {
	return predicate.Label(sql.FieldEQ(FieldMode, v))
}

// Conditions applies equality check predicate on the "conditions" field. It's identical to ConditionsEQ.
func Conditions(v string) predicate.Label {
	return predicate.Label(sql.FieldEQ(FieldConditions, v))
}

// CreatedAtEQ applies the EQ predicate on the "created_at" field.
func CreatedAtEQ(v time.Time) predicate.Label {
	return predicate.Label(sql.FieldEQ(FieldCreatedAt, v))
}

// CreatedAtNEQ applies the NEQ predicate on the "created_at" field.
func CreatedAtNEQ(v time.Time) predicate.Label {
	return predicate.Label(sql.FieldNEQ(FieldCreatedAt, v))
}

// CreatedAtIn applies the In predicate on the "created_at" field.
func CreatedAtIn(vs ...time.Time) predicate.Label {
	return predicate.Label(sql.FieldIn(FieldCreatedAt, vs...))
}

// CreatedAtNotIn applies the NotIn predicate on the "created_at" field.
func CreatedAtNotIn(vs ...time.Time) predicate.Label {
	return predicate.Label(sql.FieldNotIn(FieldCreatedAt, vs...))
}

// CreatedAtGT applies the GT predicate on the "created_at" field.
func CreatedAtGT(v time.Time) predicate.Label {
	return predicate.Label(sql.FieldGT(FieldCreatedAt, v))
}

// CreatedAtGTE applies the GTE predicate on the "created_at" field.
func CreatedAtGTE(v time.Time) predicate.Label {
	return predicate.Label(sql.FieldGTE(FieldCreatedAt, v))
}

// CreatedAtLT applies the LT predicate on the "created_at" field.
func CreatedAtLT(v time.Time) predicate.Label {
	return predicate.Label(sql.FieldLT(FieldCreatedAt, v))
}

// CreatedAtLTE applies the LTE predicate on the "created_at" field.
func CreatedAtLTE(v time.Time) predicate.Label {
	return predicate.Label(sql.FieldLTE(FieldCreatedAt, v))
}

// UpdatedAtEQ applies the EQ predicate on the "updated_at" field.
func UpdatedAtEQ(v time.Time) predicate.Label {
	return predicate.Label(sql.FieldEQ(FieldUpdatedAt, v))
}

// UpdatedAtNEQ applies the NEQ predicate on the "updated_at" field.
func UpdatedAtNEQ(v time.Time) predicate.Label {
	return predicate.Label(sql.FieldNEQ(FieldUpdatedAt, v))
}

// UpdatedAtIn applies the In predicate on the "updated_at" field.
func UpdatedAtIn(vs ...time.Time) predicate.Label {
	return predicate.Label(sql.FieldIn(FieldUpdatedAt, vs...))
}

// UpdatedAtNotIn applies the NotIn predicate on the "updated_at" field.
func UpdatedAtNotIn(vs ...time.Time) predicate.Label {
	return predicate.Label(sql.FieldNotIn(FieldUpdatedAt, vs...))
}

// UpdatedAtGT applies the GT predicate on the "updated_at" field.
func UpdatedAtGT(v time.Time) predicate.Label {
	return predicate.Label(sql.FieldGT(FieldUpdatedAt, v))
}

// UpdatedAtGTE applies the GTE predicate on the "updated_at" field.
func UpdatedAtGTE(v time.Time) predicate.Label {
	return predicate.Label(sql.FieldGTE(FieldUpdatedAt, v))
}

// UpdatedAtLT applies the LT predicate on the "updated_at" field.
func UpdatedAtLT(v time.Time) predicate.Label {
	return predicate.Label(sql.FieldLT(FieldUpdatedAt, v))
}

// UpdatedAtLTE applies the LTE predicate on the "updated_at" field.
func UpdatedAtLTE(v time.Time) predicate.Label {
	return predicate.Label(sql.FieldLTE(FieldUpdatedAt, v))
}

// StatusEQ applies the EQ predicate on the "status" field.
func StatusEQ(v uint8) predicate.Label {
	return predicate.Label(sql.FieldEQ(FieldStatus, v))
}

// StatusNEQ applies the NEQ predicate on the "status" field.
func StatusNEQ(v uint8) predicate.Label {
	return predicate.Label(sql.FieldNEQ(FieldStatus, v))
}

// StatusIn applies the In predicate on the "status" field.
func StatusIn(vs ...uint8) predicate.Label {
	return predicate.Label(sql.FieldIn(FieldStatus, vs...))
}

// StatusNotIn applies the NotIn predicate on the "status" field.
func StatusNotIn(vs ...uint8) predicate.Label {
	return predicate.Label(sql.FieldNotIn(FieldStatus, vs...))
}

// StatusGT applies the GT predicate on the "status" field.
func StatusGT(v uint8) predicate.Label {
	return predicate.Label(sql.FieldGT(FieldStatus, v))
}

// StatusGTE applies the GTE predicate on the "status" field.
func StatusGTE(v uint8) predicate.Label {
	return predicate.Label(sql.FieldGTE(FieldStatus, v))
}

// StatusLT applies the LT predicate on the "status" field.
func StatusLT(v uint8) predicate.Label {
	return predicate.Label(sql.FieldLT(FieldStatus, v))
}

// StatusLTE applies the LTE predicate on the "status" field.
func StatusLTE(v uint8) predicate.Label {
	return predicate.Label(sql.FieldLTE(FieldStatus, v))
}

// StatusIsNil applies the IsNil predicate on the "status" field.
func StatusIsNil() predicate.Label {
	return predicate.Label(sql.FieldIsNull(FieldStatus))
}

// StatusNotNil applies the NotNil predicate on the "status" field.
func StatusNotNil() predicate.Label {
	return predicate.Label(sql.FieldNotNull(FieldStatus))
}

// DeletedAtEQ applies the EQ predicate on the "deleted_at" field.
func DeletedAtEQ(v time.Time) predicate.Label {
	return predicate.Label(sql.FieldEQ(FieldDeletedAt, v))
}

// DeletedAtNEQ applies the NEQ predicate on the "deleted_at" field.
func DeletedAtNEQ(v time.Time) predicate.Label {
	return predicate.Label(sql.FieldNEQ(FieldDeletedAt, v))
}

// DeletedAtIn applies the In predicate on the "deleted_at" field.
func DeletedAtIn(vs ...time.Time) predicate.Label {
	return predicate.Label(sql.FieldIn(FieldDeletedAt, vs...))
}

// DeletedAtNotIn applies the NotIn predicate on the "deleted_at" field.
func DeletedAtNotIn(vs ...time.Time) predicate.Label {
	return predicate.Label(sql.FieldNotIn(FieldDeletedAt, vs...))
}

// DeletedAtGT applies the GT predicate on the "deleted_at" field.
func DeletedAtGT(v time.Time) predicate.Label {
	return predicate.Label(sql.FieldGT(FieldDeletedAt, v))
}

// DeletedAtGTE applies the GTE predicate on the "deleted_at" field.
func DeletedAtGTE(v time.Time) predicate.Label {
	return predicate.Label(sql.FieldGTE(FieldDeletedAt, v))
}

// DeletedAtLT applies the LT predicate on the "deleted_at" field.
func DeletedAtLT(v time.Time) predicate.Label {
	return predicate.Label(sql.FieldLT(FieldDeletedAt, v))
}

// DeletedAtLTE applies the LTE predicate on the "deleted_at" field.
func DeletedAtLTE(v time.Time) predicate.Label {
	return predicate.Label(sql.FieldLTE(FieldDeletedAt, v))
}

// DeletedAtIsNil applies the IsNil predicate on the "deleted_at" field.
func DeletedAtIsNil() predicate.Label {
	return predicate.Label(sql.FieldIsNull(FieldDeletedAt))
}

// DeletedAtNotNil applies the NotNil predicate on the "deleted_at" field.
func DeletedAtNotNil() predicate.Label {
	return predicate.Label(sql.FieldNotNull(FieldDeletedAt))
}

// TypeEQ applies the EQ predicate on the "type" field.
func TypeEQ(v int) predicate.Label {
	return predicate.Label(sql.FieldEQ(FieldType, v))
}

// TypeNEQ applies the NEQ predicate on the "type" field.
func TypeNEQ(v int) predicate.Label {
	return predicate.Label(sql.FieldNEQ(FieldType, v))
}

// TypeIn applies the In predicate on the "type" field.
func TypeIn(vs ...int) predicate.Label {
	return predicate.Label(sql.FieldIn(FieldType, vs...))
}

// TypeNotIn applies the NotIn predicate on the "type" field.
func TypeNotIn(vs ...int) predicate.Label {
	return predicate.Label(sql.FieldNotIn(FieldType, vs...))
}

// TypeGT applies the GT predicate on the "type" field.
func TypeGT(v int) predicate.Label {
	return predicate.Label(sql.FieldGT(FieldType, v))
}

// TypeGTE applies the GTE predicate on the "type" field.
func TypeGTE(v int) predicate.Label {
	return predicate.Label(sql.FieldGTE(FieldType, v))
}

// TypeLT applies the LT predicate on the "type" field.
func TypeLT(v int) predicate.Label {
	return predicate.Label(sql.FieldLT(FieldType, v))
}

// TypeLTE applies the LTE predicate on the "type" field.
func TypeLTE(v int) predicate.Label {
	return predicate.Label(sql.FieldLTE(FieldType, v))
}

// NameEQ applies the EQ predicate on the "name" field.
func NameEQ(v string) predicate.Label {
	return predicate.Label(sql.FieldEQ(FieldName, v))
}

// NameNEQ applies the NEQ predicate on the "name" field.
func NameNEQ(v string) predicate.Label {
	return predicate.Label(sql.FieldNEQ(FieldName, v))
}

// NameIn applies the In predicate on the "name" field.
func NameIn(vs ...string) predicate.Label {
	return predicate.Label(sql.FieldIn(FieldName, vs...))
}

// NameNotIn applies the NotIn predicate on the "name" field.
func NameNotIn(vs ...string) predicate.Label {
	return predicate.Label(sql.FieldNotIn(FieldName, vs...))
}

// NameGT applies the GT predicate on the "name" field.
func NameGT(v string) predicate.Label {
	return predicate.Label(sql.FieldGT(FieldName, v))
}

// NameGTE applies the GTE predicate on the "name" field.
func NameGTE(v string) predicate.Label {
	return predicate.Label(sql.FieldGTE(FieldName, v))
}

// NameLT applies the LT predicate on the "name" field.
func NameLT(v string) predicate.Label {
	return predicate.Label(sql.FieldLT(FieldName, v))
}

// NameLTE applies the LTE predicate on the "name" field.
func NameLTE(v string) predicate.Label {
	return predicate.Label(sql.FieldLTE(FieldName, v))
}

// NameContains applies the Contains predicate on the "name" field.
func NameContains(v string) predicate.Label {
	return predicate.Label(sql.FieldContains(FieldName, v))
}

// NameHasPrefix applies the HasPrefix predicate on the "name" field.
func NameHasPrefix(v string) predicate.Label {
	return predicate.Label(sql.FieldHasPrefix(FieldName, v))
}

// NameHasSuffix applies the HasSuffix predicate on the "name" field.
func NameHasSuffix(v string) predicate.Label {
	return predicate.Label(sql.FieldHasSuffix(FieldName, v))
}

// NameEqualFold applies the EqualFold predicate on the "name" field.
func NameEqualFold(v string) predicate.Label {
	return predicate.Label(sql.FieldEqualFold(FieldName, v))
}

// NameContainsFold applies the ContainsFold predicate on the "name" field.
func NameContainsFold(v string) predicate.Label {
	return predicate.Label(sql.FieldContainsFold(FieldName, v))
}

// FromEQ applies the EQ predicate on the "from" field.
func FromEQ(v int) predicate.Label {
	return predicate.Label(sql.FieldEQ(FieldFrom, v))
}

// FromNEQ applies the NEQ predicate on the "from" field.
func FromNEQ(v int) predicate.Label {
	return predicate.Label(sql.FieldNEQ(FieldFrom, v))
}

// FromIn applies the In predicate on the "from" field.
func FromIn(vs ...int) predicate.Label {
	return predicate.Label(sql.FieldIn(FieldFrom, vs...))
}

// FromNotIn applies the NotIn predicate on the "from" field.
func FromNotIn(vs ...int) predicate.Label {
	return predicate.Label(sql.FieldNotIn(FieldFrom, vs...))
}

// FromGT applies the GT predicate on the "from" field.
func FromGT(v int) predicate.Label {
	return predicate.Label(sql.FieldGT(FieldFrom, v))
}

// FromGTE applies the GTE predicate on the "from" field.
func FromGTE(v int) predicate.Label {
	return predicate.Label(sql.FieldGTE(FieldFrom, v))
}

// FromLT applies the LT predicate on the "from" field.
func FromLT(v int) predicate.Label {
	return predicate.Label(sql.FieldLT(FieldFrom, v))
}

// FromLTE applies the LTE predicate on the "from" field.
func FromLTE(v int) predicate.Label {
	return predicate.Label(sql.FieldLTE(FieldFrom, v))
}

// ModeEQ applies the EQ predicate on the "mode" field.
func ModeEQ(v int) predicate.Label {
	return predicate.Label(sql.FieldEQ(FieldMode, v))
}

// ModeNEQ applies the NEQ predicate on the "mode" field.
func ModeNEQ(v int) predicate.Label {
	return predicate.Label(sql.FieldNEQ(FieldMode, v))
}

// ModeIn applies the In predicate on the "mode" field.
func ModeIn(vs ...int) predicate.Label {
	return predicate.Label(sql.FieldIn(FieldMode, vs...))
}

// ModeNotIn applies the NotIn predicate on the "mode" field.
func ModeNotIn(vs ...int) predicate.Label {
	return predicate.Label(sql.FieldNotIn(FieldMode, vs...))
}

// ModeGT applies the GT predicate on the "mode" field.
func ModeGT(v int) predicate.Label {
	return predicate.Label(sql.FieldGT(FieldMode, v))
}

// ModeGTE applies the GTE predicate on the "mode" field.
func ModeGTE(v int) predicate.Label {
	return predicate.Label(sql.FieldGTE(FieldMode, v))
}

// ModeLT applies the LT predicate on the "mode" field.
func ModeLT(v int) predicate.Label {
	return predicate.Label(sql.FieldLT(FieldMode, v))
}

// ModeLTE applies the LTE predicate on the "mode" field.
func ModeLTE(v int) predicate.Label {
	return predicate.Label(sql.FieldLTE(FieldMode, v))
}

// ConditionsEQ applies the EQ predicate on the "conditions" field.
func ConditionsEQ(v string) predicate.Label {
	return predicate.Label(sql.FieldEQ(FieldConditions, v))
}

// ConditionsNEQ applies the NEQ predicate on the "conditions" field.
func ConditionsNEQ(v string) predicate.Label {
	return predicate.Label(sql.FieldNEQ(FieldConditions, v))
}

// ConditionsIn applies the In predicate on the "conditions" field.
func ConditionsIn(vs ...string) predicate.Label {
	return predicate.Label(sql.FieldIn(FieldConditions, vs...))
}

// ConditionsNotIn applies the NotIn predicate on the "conditions" field.
func ConditionsNotIn(vs ...string) predicate.Label {
	return predicate.Label(sql.FieldNotIn(FieldConditions, vs...))
}

// ConditionsGT applies the GT predicate on the "conditions" field.
func ConditionsGT(v string) predicate.Label {
	return predicate.Label(sql.FieldGT(FieldConditions, v))
}

// ConditionsGTE applies the GTE predicate on the "conditions" field.
func ConditionsGTE(v string) predicate.Label {
	return predicate.Label(sql.FieldGTE(FieldConditions, v))
}

// ConditionsLT applies the LT predicate on the "conditions" field.
func ConditionsLT(v string) predicate.Label {
	return predicate.Label(sql.FieldLT(FieldConditions, v))
}

// ConditionsLTE applies the LTE predicate on the "conditions" field.
func ConditionsLTE(v string) predicate.Label {
	return predicate.Label(sql.FieldLTE(FieldConditions, v))
}

// ConditionsContains applies the Contains predicate on the "conditions" field.
func ConditionsContains(v string) predicate.Label {
	return predicate.Label(sql.FieldContains(FieldConditions, v))
}

// ConditionsHasPrefix applies the HasPrefix predicate on the "conditions" field.
func ConditionsHasPrefix(v string) predicate.Label {
	return predicate.Label(sql.FieldHasPrefix(FieldConditions, v))
}

// ConditionsHasSuffix applies the HasSuffix predicate on the "conditions" field.
func ConditionsHasSuffix(v string) predicate.Label {
	return predicate.Label(sql.FieldHasSuffix(FieldConditions, v))
}

// ConditionsIsNil applies the IsNil predicate on the "conditions" field.
func ConditionsIsNil() predicate.Label {
	return predicate.Label(sql.FieldIsNull(FieldConditions))
}

// ConditionsNotNil applies the NotNil predicate on the "conditions" field.
func ConditionsNotNil() predicate.Label {
	return predicate.Label(sql.FieldNotNull(FieldConditions))
}

// ConditionsEqualFold applies the EqualFold predicate on the "conditions" field.
func ConditionsEqualFold(v string) predicate.Label {
	return predicate.Label(sql.FieldEqualFold(FieldConditions, v))
}

// ConditionsContainsFold applies the ContainsFold predicate on the "conditions" field.
func ConditionsContainsFold(v string) predicate.Label {
	return predicate.Label(sql.FieldContainsFold(FieldConditions, v))
}

// HasLabelRelationships applies the HasEdge predicate on the "label_relationships" edge.
func HasLabelRelationships() predicate.Label {
	return predicate.Label(func(s *sql.Selector) {
		step := sqlgraph.NewStep(
			sqlgraph.From(Table, FieldID),
			sqlgraph.Edge(sqlgraph.O2M, false, LabelRelationshipsTable, LabelRelationshipsColumn),
		)
		sqlgraph.HasNeighbors(s, step)
	})
}

// HasLabelRelationshipsWith applies the HasEdge predicate on the "label_relationships" edge with a given conditions (other predicates).
func HasLabelRelationshipsWith(preds ...predicate.LabelRelationship) predicate.Label {
	return predicate.Label(func(s *sql.Selector) {
		step := newLabelRelationshipsStep()
		sqlgraph.HasNeighborsWith(s, step, func(s *sql.Selector) {
			for _, p := range preds {
				p(s)
			}
		})
	})
}

// And groups predicates with the AND operator between them.
func And(predicates ...predicate.Label) predicate.Label {
	return predicate.Label(sql.AndPredicates(predicates...))
}

// Or groups predicates with the OR operator between them.
func Or(predicates ...predicate.Label) predicate.Label {
	return predicate.Label(sql.OrPredicates(predicates...))
}

// Not applies the not operator on the given predicate.
func Not(p predicate.Label) predicate.Label {
	return predicate.Label(sql.NotPredicates(p))
}
