// Code generated by ent, DO NOT EDIT.

package ent

import (
	"context"
	"errors"
	"fmt"
	"time"
	"wechat-api/ent/contact"
	"wechat-api/ent/label"
	"wechat-api/ent/labelrelationship"

	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
	"entgo.io/ent/schema/field"
)

// LabelRelationshipCreate is the builder for creating a LabelRelationship entity.
type LabelRelationshipCreate struct {
	config
	mutation *LabelRelationshipMutation
	hooks    []Hook
	conflict []sql.ConflictOption
}

// SetCreatedAt sets the "created_at" field.
func (lrc *LabelRelationshipCreate) SetCreatedAt(t time.Time) *LabelRelationshipCreate {
	lrc.mutation.SetCreatedAt(t)
	return lrc
}

// SetNillableCreatedAt sets the "created_at" field if the given value is not nil.
func (lrc *LabelRelationshipCreate) SetNillableCreatedAt(t *time.Time) *LabelRelationshipCreate {
	if t != nil {
		lrc.SetCreatedAt(*t)
	}
	return lrc
}

// SetUpdatedAt sets the "updated_at" field.
func (lrc *LabelRelationshipCreate) SetUpdatedAt(t time.Time) *LabelRelationshipCreate {
	lrc.mutation.SetUpdatedAt(t)
	return lrc
}

// SetNillableUpdatedAt sets the "updated_at" field if the given value is not nil.
func (lrc *LabelRelationshipCreate) SetNillableUpdatedAt(t *time.Time) *LabelRelationshipCreate {
	if t != nil {
		lrc.SetUpdatedAt(*t)
	}
	return lrc
}

// SetStatus sets the "status" field.
func (lrc *LabelRelationshipCreate) SetStatus(u uint8) *LabelRelationshipCreate {
	lrc.mutation.SetStatus(u)
	return lrc
}

// SetNillableStatus sets the "status" field if the given value is not nil.
func (lrc *LabelRelationshipCreate) SetNillableStatus(u *uint8) *LabelRelationshipCreate {
	if u != nil {
		lrc.SetStatus(*u)
	}
	return lrc
}

// SetDeletedAt sets the "deleted_at" field.
func (lrc *LabelRelationshipCreate) SetDeletedAt(t time.Time) *LabelRelationshipCreate {
	lrc.mutation.SetDeletedAt(t)
	return lrc
}

// SetNillableDeletedAt sets the "deleted_at" field if the given value is not nil.
func (lrc *LabelRelationshipCreate) SetNillableDeletedAt(t *time.Time) *LabelRelationshipCreate {
	if t != nil {
		lrc.SetDeletedAt(*t)
	}
	return lrc
}

// SetLabelID sets the "label_id" field.
func (lrc *LabelRelationshipCreate) SetLabelID(u uint64) *LabelRelationshipCreate {
	lrc.mutation.SetLabelID(u)
	return lrc
}

// SetNillableLabelID sets the "label_id" field if the given value is not nil.
func (lrc *LabelRelationshipCreate) SetNillableLabelID(u *uint64) *LabelRelationshipCreate {
	if u != nil {
		lrc.SetLabelID(*u)
	}
	return lrc
}

// SetContactID sets the "contact_id" field.
func (lrc *LabelRelationshipCreate) SetContactID(u uint64) *LabelRelationshipCreate {
	lrc.mutation.SetContactID(u)
	return lrc
}

// SetNillableContactID sets the "contact_id" field if the given value is not nil.
func (lrc *LabelRelationshipCreate) SetNillableContactID(u *uint64) *LabelRelationshipCreate {
	if u != nil {
		lrc.SetContactID(*u)
	}
	return lrc
}

// SetID sets the "id" field.
func (lrc *LabelRelationshipCreate) SetID(u uint64) *LabelRelationshipCreate {
	lrc.mutation.SetID(u)
	return lrc
}

// SetContactsID sets the "contacts" edge to the Contact entity by ID.
func (lrc *LabelRelationshipCreate) SetContactsID(id uint64) *LabelRelationshipCreate {
	lrc.mutation.SetContactsID(id)
	return lrc
}

// SetContacts sets the "contacts" edge to the Contact entity.
func (lrc *LabelRelationshipCreate) SetContacts(c *Contact) *LabelRelationshipCreate {
	return lrc.SetContactsID(c.ID)
}

// SetLabelsID sets the "labels" edge to the Label entity by ID.
func (lrc *LabelRelationshipCreate) SetLabelsID(id uint64) *LabelRelationshipCreate {
	lrc.mutation.SetLabelsID(id)
	return lrc
}

// SetLabels sets the "labels" edge to the Label entity.
func (lrc *LabelRelationshipCreate) SetLabels(l *Label) *LabelRelationshipCreate {
	return lrc.SetLabelsID(l.ID)
}

// Mutation returns the LabelRelationshipMutation object of the builder.
func (lrc *LabelRelationshipCreate) Mutation() *LabelRelationshipMutation {
	return lrc.mutation
}

// Save creates the LabelRelationship in the database.
func (lrc *LabelRelationshipCreate) Save(ctx context.Context) (*LabelRelationship, error) {
	if err := lrc.defaults(); err != nil {
		return nil, err
	}
	return withHooks(ctx, lrc.sqlSave, lrc.mutation, lrc.hooks)
}

// SaveX calls Save and panics if Save returns an error.
func (lrc *LabelRelationshipCreate) SaveX(ctx context.Context) *LabelRelationship {
	v, err := lrc.Save(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Exec executes the query.
func (lrc *LabelRelationshipCreate) Exec(ctx context.Context) error {
	_, err := lrc.Save(ctx)
	return err
}

// ExecX is like Exec, but panics if an error occurs.
func (lrc *LabelRelationshipCreate) ExecX(ctx context.Context) {
	if err := lrc.Exec(ctx); err != nil {
		panic(err)
	}
}

// defaults sets the default values of the builder before save.
func (lrc *LabelRelationshipCreate) defaults() error {
	if _, ok := lrc.mutation.CreatedAt(); !ok {
		if labelrelationship.DefaultCreatedAt == nil {
			return fmt.Errorf("ent: uninitialized labelrelationship.DefaultCreatedAt (forgotten import ent/runtime?)")
		}
		v := labelrelationship.DefaultCreatedAt()
		lrc.mutation.SetCreatedAt(v)
	}
	if _, ok := lrc.mutation.UpdatedAt(); !ok {
		if labelrelationship.DefaultUpdatedAt == nil {
			return fmt.Errorf("ent: uninitialized labelrelationship.DefaultUpdatedAt (forgotten import ent/runtime?)")
		}
		v := labelrelationship.DefaultUpdatedAt()
		lrc.mutation.SetUpdatedAt(v)
	}
	if _, ok := lrc.mutation.Status(); !ok {
		v := labelrelationship.DefaultStatus
		lrc.mutation.SetStatus(v)
	}
	if _, ok := lrc.mutation.LabelID(); !ok {
		v := labelrelationship.DefaultLabelID
		lrc.mutation.SetLabelID(v)
	}
	if _, ok := lrc.mutation.ContactID(); !ok {
		v := labelrelationship.DefaultContactID
		lrc.mutation.SetContactID(v)
	}
	return nil
}

// check runs all checks and user-defined validators on the builder.
func (lrc *LabelRelationshipCreate) check() error {
	if _, ok := lrc.mutation.CreatedAt(); !ok {
		return &ValidationError{Name: "created_at", err: errors.New(`ent: missing required field "LabelRelationship.created_at"`)}
	}
	if _, ok := lrc.mutation.UpdatedAt(); !ok {
		return &ValidationError{Name: "updated_at", err: errors.New(`ent: missing required field "LabelRelationship.updated_at"`)}
	}
	if _, ok := lrc.mutation.LabelID(); !ok {
		return &ValidationError{Name: "label_id", err: errors.New(`ent: missing required field "LabelRelationship.label_id"`)}
	}
	if _, ok := lrc.mutation.ContactID(); !ok {
		return &ValidationError{Name: "contact_id", err: errors.New(`ent: missing required field "LabelRelationship.contact_id"`)}
	}
	if _, ok := lrc.mutation.ContactsID(); !ok {
		return &ValidationError{Name: "contacts", err: errors.New(`ent: missing required edge "LabelRelationship.contacts"`)}
	}
	if _, ok := lrc.mutation.LabelsID(); !ok {
		return &ValidationError{Name: "labels", err: errors.New(`ent: missing required edge "LabelRelationship.labels"`)}
	}
	return nil
}

func (lrc *LabelRelationshipCreate) sqlSave(ctx context.Context) (*LabelRelationship, error) {
	if err := lrc.check(); err != nil {
		return nil, err
	}
	_node, _spec := lrc.createSpec()
	if err := sqlgraph.CreateNode(ctx, lrc.driver, _spec); err != nil {
		if sqlgraph.IsConstraintError(err) {
			err = &ConstraintError{msg: err.Error(), wrap: err}
		}
		return nil, err
	}
	if _spec.ID.Value != _node.ID {
		id := _spec.ID.Value.(int64)
		_node.ID = uint64(id)
	}
	lrc.mutation.id = &_node.ID
	lrc.mutation.done = true
	return _node, nil
}

func (lrc *LabelRelationshipCreate) createSpec() (*LabelRelationship, *sqlgraph.CreateSpec) {
	var (
		_node = &LabelRelationship{config: lrc.config}
		_spec = sqlgraph.NewCreateSpec(labelrelationship.Table, sqlgraph.NewFieldSpec(labelrelationship.FieldID, field.TypeUint64))
	)
	_spec.OnConflict = lrc.conflict
	if id, ok := lrc.mutation.ID(); ok {
		_node.ID = id
		_spec.ID.Value = id
	}
	if value, ok := lrc.mutation.CreatedAt(); ok {
		_spec.SetField(labelrelationship.FieldCreatedAt, field.TypeTime, value)
		_node.CreatedAt = value
	}
	if value, ok := lrc.mutation.UpdatedAt(); ok {
		_spec.SetField(labelrelationship.FieldUpdatedAt, field.TypeTime, value)
		_node.UpdatedAt = value
	}
	if value, ok := lrc.mutation.Status(); ok {
		_spec.SetField(labelrelationship.FieldStatus, field.TypeUint8, value)
		_node.Status = value
	}
	if value, ok := lrc.mutation.DeletedAt(); ok {
		_spec.SetField(labelrelationship.FieldDeletedAt, field.TypeTime, value)
		_node.DeletedAt = value
	}
	if nodes := lrc.mutation.ContactsIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2O,
			Inverse: true,
			Table:   labelrelationship.ContactsTable,
			Columns: []string{labelrelationship.ContactsColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(contact.FieldID, field.TypeUint64),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_node.ContactID = nodes[0]
		_spec.Edges = append(_spec.Edges, edge)
	}
	if nodes := lrc.mutation.LabelsIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2O,
			Inverse: true,
			Table:   labelrelationship.LabelsTable,
			Columns: []string{labelrelationship.LabelsColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(label.FieldID, field.TypeUint64),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_node.LabelID = nodes[0]
		_spec.Edges = append(_spec.Edges, edge)
	}
	return _node, _spec
}

// OnConflict allows configuring the `ON CONFLICT` / `ON DUPLICATE KEY` clause
// of the `INSERT` statement. For example:
//
//	client.LabelRelationship.Create().
//		SetCreatedAt(v).
//		OnConflict(
//			// Update the row with the new values
//			// the was proposed for insertion.
//			sql.ResolveWithNewValues(),
//		).
//		// Override some of the fields with custom
//		// update values.
//		Update(func(u *ent.LabelRelationshipUpsert) {
//			SetCreatedAt(v+v).
//		}).
//		Exec(ctx)
func (lrc *LabelRelationshipCreate) OnConflict(opts ...sql.ConflictOption) *LabelRelationshipUpsertOne {
	lrc.conflict = opts
	return &LabelRelationshipUpsertOne{
		create: lrc,
	}
}

// OnConflictColumns calls `OnConflict` and configures the columns
// as conflict target. Using this option is equivalent to using:
//
//	client.LabelRelationship.Create().
//		OnConflict(sql.ConflictColumns(columns...)).
//		Exec(ctx)
func (lrc *LabelRelationshipCreate) OnConflictColumns(columns ...string) *LabelRelationshipUpsertOne {
	lrc.conflict = append(lrc.conflict, sql.ConflictColumns(columns...))
	return &LabelRelationshipUpsertOne{
		create: lrc,
	}
}

type (
	// LabelRelationshipUpsertOne is the builder for "upsert"-ing
	//  one LabelRelationship node.
	LabelRelationshipUpsertOne struct {
		create *LabelRelationshipCreate
	}

	// LabelRelationshipUpsert is the "OnConflict" setter.
	LabelRelationshipUpsert struct {
		*sql.UpdateSet
	}
)

// SetUpdatedAt sets the "updated_at" field.
func (u *LabelRelationshipUpsert) SetUpdatedAt(v time.Time) *LabelRelationshipUpsert {
	u.Set(labelrelationship.FieldUpdatedAt, v)
	return u
}

// UpdateUpdatedAt sets the "updated_at" field to the value that was provided on create.
func (u *LabelRelationshipUpsert) UpdateUpdatedAt() *LabelRelationshipUpsert {
	u.SetExcluded(labelrelationship.FieldUpdatedAt)
	return u
}

// SetStatus sets the "status" field.
func (u *LabelRelationshipUpsert) SetStatus(v uint8) *LabelRelationshipUpsert {
	u.Set(labelrelationship.FieldStatus, v)
	return u
}

// UpdateStatus sets the "status" field to the value that was provided on create.
func (u *LabelRelationshipUpsert) UpdateStatus() *LabelRelationshipUpsert {
	u.SetExcluded(labelrelationship.FieldStatus)
	return u
}

// AddStatus adds v to the "status" field.
func (u *LabelRelationshipUpsert) AddStatus(v uint8) *LabelRelationshipUpsert {
	u.Add(labelrelationship.FieldStatus, v)
	return u
}

// ClearStatus clears the value of the "status" field.
func (u *LabelRelationshipUpsert) ClearStatus() *LabelRelationshipUpsert {
	u.SetNull(labelrelationship.FieldStatus)
	return u
}

// SetDeletedAt sets the "deleted_at" field.
func (u *LabelRelationshipUpsert) SetDeletedAt(v time.Time) *LabelRelationshipUpsert {
	u.Set(labelrelationship.FieldDeletedAt, v)
	return u
}

// UpdateDeletedAt sets the "deleted_at" field to the value that was provided on create.
func (u *LabelRelationshipUpsert) UpdateDeletedAt() *LabelRelationshipUpsert {
	u.SetExcluded(labelrelationship.FieldDeletedAt)
	return u
}

// ClearDeletedAt clears the value of the "deleted_at" field.
func (u *LabelRelationshipUpsert) ClearDeletedAt() *LabelRelationshipUpsert {
	u.SetNull(labelrelationship.FieldDeletedAt)
	return u
}

// SetLabelID sets the "label_id" field.
func (u *LabelRelationshipUpsert) SetLabelID(v uint64) *LabelRelationshipUpsert {
	u.Set(labelrelationship.FieldLabelID, v)
	return u
}

// UpdateLabelID sets the "label_id" field to the value that was provided on create.
func (u *LabelRelationshipUpsert) UpdateLabelID() *LabelRelationshipUpsert {
	u.SetExcluded(labelrelationship.FieldLabelID)
	return u
}

// SetContactID sets the "contact_id" field.
func (u *LabelRelationshipUpsert) SetContactID(v uint64) *LabelRelationshipUpsert {
	u.Set(labelrelationship.FieldContactID, v)
	return u
}

// UpdateContactID sets the "contact_id" field to the value that was provided on create.
func (u *LabelRelationshipUpsert) UpdateContactID() *LabelRelationshipUpsert {
	u.SetExcluded(labelrelationship.FieldContactID)
	return u
}

// UpdateNewValues updates the mutable fields using the new values that were set on create except the ID field.
// Using this option is equivalent to using:
//
//	client.LabelRelationship.Create().
//		OnConflict(
//			sql.ResolveWithNewValues(),
//			sql.ResolveWith(func(u *sql.UpdateSet) {
//				u.SetIgnore(labelrelationship.FieldID)
//			}),
//		).
//		Exec(ctx)
func (u *LabelRelationshipUpsertOne) UpdateNewValues() *LabelRelationshipUpsertOne {
	u.create.conflict = append(u.create.conflict, sql.ResolveWithNewValues())
	u.create.conflict = append(u.create.conflict, sql.ResolveWith(func(s *sql.UpdateSet) {
		if _, exists := u.create.mutation.ID(); exists {
			s.SetIgnore(labelrelationship.FieldID)
		}
		if _, exists := u.create.mutation.CreatedAt(); exists {
			s.SetIgnore(labelrelationship.FieldCreatedAt)
		}
	}))
	return u
}

// Ignore sets each column to itself in case of conflict.
// Using this option is equivalent to using:
//
//	client.LabelRelationship.Create().
//	    OnConflict(sql.ResolveWithIgnore()).
//	    Exec(ctx)
func (u *LabelRelationshipUpsertOne) Ignore() *LabelRelationshipUpsertOne {
	u.create.conflict = append(u.create.conflict, sql.ResolveWithIgnore())
	return u
}

// DoNothing configures the conflict_action to `DO NOTHING`.
// Supported only by SQLite and PostgreSQL.
func (u *LabelRelationshipUpsertOne) DoNothing() *LabelRelationshipUpsertOne {
	u.create.conflict = append(u.create.conflict, sql.DoNothing())
	return u
}

// Update allows overriding fields `UPDATE` values. See the LabelRelationshipCreate.OnConflict
// documentation for more info.
func (u *LabelRelationshipUpsertOne) Update(set func(*LabelRelationshipUpsert)) *LabelRelationshipUpsertOne {
	u.create.conflict = append(u.create.conflict, sql.ResolveWith(func(update *sql.UpdateSet) {
		set(&LabelRelationshipUpsert{UpdateSet: update})
	}))
	return u
}

// SetUpdatedAt sets the "updated_at" field.
func (u *LabelRelationshipUpsertOne) SetUpdatedAt(v time.Time) *LabelRelationshipUpsertOne {
	return u.Update(func(s *LabelRelationshipUpsert) {
		s.SetUpdatedAt(v)
	})
}

// UpdateUpdatedAt sets the "updated_at" field to the value that was provided on create.
func (u *LabelRelationshipUpsertOne) UpdateUpdatedAt() *LabelRelationshipUpsertOne {
	return u.Update(func(s *LabelRelationshipUpsert) {
		s.UpdateUpdatedAt()
	})
}

// SetStatus sets the "status" field.
func (u *LabelRelationshipUpsertOne) SetStatus(v uint8) *LabelRelationshipUpsertOne {
	return u.Update(func(s *LabelRelationshipUpsert) {
		s.SetStatus(v)
	})
}

// AddStatus adds v to the "status" field.
func (u *LabelRelationshipUpsertOne) AddStatus(v uint8) *LabelRelationshipUpsertOne {
	return u.Update(func(s *LabelRelationshipUpsert) {
		s.AddStatus(v)
	})
}

// UpdateStatus sets the "status" field to the value that was provided on create.
func (u *LabelRelationshipUpsertOne) UpdateStatus() *LabelRelationshipUpsertOne {
	return u.Update(func(s *LabelRelationshipUpsert) {
		s.UpdateStatus()
	})
}

// ClearStatus clears the value of the "status" field.
func (u *LabelRelationshipUpsertOne) ClearStatus() *LabelRelationshipUpsertOne {
	return u.Update(func(s *LabelRelationshipUpsert) {
		s.ClearStatus()
	})
}

// SetDeletedAt sets the "deleted_at" field.
func (u *LabelRelationshipUpsertOne) SetDeletedAt(v time.Time) *LabelRelationshipUpsertOne {
	return u.Update(func(s *LabelRelationshipUpsert) {
		s.SetDeletedAt(v)
	})
}

// UpdateDeletedAt sets the "deleted_at" field to the value that was provided on create.
func (u *LabelRelationshipUpsertOne) UpdateDeletedAt() *LabelRelationshipUpsertOne {
	return u.Update(func(s *LabelRelationshipUpsert) {
		s.UpdateDeletedAt()
	})
}

// ClearDeletedAt clears the value of the "deleted_at" field.
func (u *LabelRelationshipUpsertOne) ClearDeletedAt() *LabelRelationshipUpsertOne {
	return u.Update(func(s *LabelRelationshipUpsert) {
		s.ClearDeletedAt()
	})
}

// SetLabelID sets the "label_id" field.
func (u *LabelRelationshipUpsertOne) SetLabelID(v uint64) *LabelRelationshipUpsertOne {
	return u.Update(func(s *LabelRelationshipUpsert) {
		s.SetLabelID(v)
	})
}

// UpdateLabelID sets the "label_id" field to the value that was provided on create.
func (u *LabelRelationshipUpsertOne) UpdateLabelID() *LabelRelationshipUpsertOne {
	return u.Update(func(s *LabelRelationshipUpsert) {
		s.UpdateLabelID()
	})
}

// SetContactID sets the "contact_id" field.
func (u *LabelRelationshipUpsertOne) SetContactID(v uint64) *LabelRelationshipUpsertOne {
	return u.Update(func(s *LabelRelationshipUpsert) {
		s.SetContactID(v)
	})
}

// UpdateContactID sets the "contact_id" field to the value that was provided on create.
func (u *LabelRelationshipUpsertOne) UpdateContactID() *LabelRelationshipUpsertOne {
	return u.Update(func(s *LabelRelationshipUpsert) {
		s.UpdateContactID()
	})
}

// Exec executes the query.
func (u *LabelRelationshipUpsertOne) Exec(ctx context.Context) error {
	if len(u.create.conflict) == 0 {
		return errors.New("ent: missing options for LabelRelationshipCreate.OnConflict")
	}
	return u.create.Exec(ctx)
}

// ExecX is like Exec, but panics if an error occurs.
func (u *LabelRelationshipUpsertOne) ExecX(ctx context.Context) {
	if err := u.create.Exec(ctx); err != nil {
		panic(err)
	}
}

// Exec executes the UPSERT query and returns the inserted/updated ID.
func (u *LabelRelationshipUpsertOne) ID(ctx context.Context) (id uint64, err error) {
	node, err := u.create.Save(ctx)
	if err != nil {
		return id, err
	}
	return node.ID, nil
}

// IDX is like ID, but panics if an error occurs.
func (u *LabelRelationshipUpsertOne) IDX(ctx context.Context) uint64 {
	id, err := u.ID(ctx)
	if err != nil {
		panic(err)
	}
	return id
}

// LabelRelationshipCreateBulk is the builder for creating many LabelRelationship entities in bulk.
type LabelRelationshipCreateBulk struct {
	config
	err      error
	builders []*LabelRelationshipCreate
	conflict []sql.ConflictOption
}

// Save creates the LabelRelationship entities in the database.
func (lrcb *LabelRelationshipCreateBulk) Save(ctx context.Context) ([]*LabelRelationship, error) {
	if lrcb.err != nil {
		return nil, lrcb.err
	}
	specs := make([]*sqlgraph.CreateSpec, len(lrcb.builders))
	nodes := make([]*LabelRelationship, len(lrcb.builders))
	mutators := make([]Mutator, len(lrcb.builders))
	for i := range lrcb.builders {
		func(i int, root context.Context) {
			builder := lrcb.builders[i]
			builder.defaults()
			var mut Mutator = MutateFunc(func(ctx context.Context, m Mutation) (Value, error) {
				mutation, ok := m.(*LabelRelationshipMutation)
				if !ok {
					return nil, fmt.Errorf("unexpected mutation type %T", m)
				}
				if err := builder.check(); err != nil {
					return nil, err
				}
				builder.mutation = mutation
				var err error
				nodes[i], specs[i] = builder.createSpec()
				if i < len(mutators)-1 {
					_, err = mutators[i+1].Mutate(root, lrcb.builders[i+1].mutation)
				} else {
					spec := &sqlgraph.BatchCreateSpec{Nodes: specs}
					spec.OnConflict = lrcb.conflict
					// Invoke the actual operation on the latest mutation in the chain.
					if err = sqlgraph.BatchCreate(ctx, lrcb.driver, spec); err != nil {
						if sqlgraph.IsConstraintError(err) {
							err = &ConstraintError{msg: err.Error(), wrap: err}
						}
					}
				}
				if err != nil {
					return nil, err
				}
				mutation.id = &nodes[i].ID
				if specs[i].ID.Value != nil && nodes[i].ID == 0 {
					id := specs[i].ID.Value.(int64)
					nodes[i].ID = uint64(id)
				}
				mutation.done = true
				return nodes[i], nil
			})
			for i := len(builder.hooks) - 1; i >= 0; i-- {
				mut = builder.hooks[i](mut)
			}
			mutators[i] = mut
		}(i, ctx)
	}
	if len(mutators) > 0 {
		if _, err := mutators[0].Mutate(ctx, lrcb.builders[0].mutation); err != nil {
			return nil, err
		}
	}
	return nodes, nil
}

// SaveX is like Save, but panics if an error occurs.
func (lrcb *LabelRelationshipCreateBulk) SaveX(ctx context.Context) []*LabelRelationship {
	v, err := lrcb.Save(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Exec executes the query.
func (lrcb *LabelRelationshipCreateBulk) Exec(ctx context.Context) error {
	_, err := lrcb.Save(ctx)
	return err
}

// ExecX is like Exec, but panics if an error occurs.
func (lrcb *LabelRelationshipCreateBulk) ExecX(ctx context.Context) {
	if err := lrcb.Exec(ctx); err != nil {
		panic(err)
	}
}

// OnConflict allows configuring the `ON CONFLICT` / `ON DUPLICATE KEY` clause
// of the `INSERT` statement. For example:
//
//	client.LabelRelationship.CreateBulk(builders...).
//		OnConflict(
//			// Update the row with the new values
//			// the was proposed for insertion.
//			sql.ResolveWithNewValues(),
//		).
//		// Override some of the fields with custom
//		// update values.
//		Update(func(u *ent.LabelRelationshipUpsert) {
//			SetCreatedAt(v+v).
//		}).
//		Exec(ctx)
func (lrcb *LabelRelationshipCreateBulk) OnConflict(opts ...sql.ConflictOption) *LabelRelationshipUpsertBulk {
	lrcb.conflict = opts
	return &LabelRelationshipUpsertBulk{
		create: lrcb,
	}
}

// OnConflictColumns calls `OnConflict` and configures the columns
// as conflict target. Using this option is equivalent to using:
//
//	client.LabelRelationship.Create().
//		OnConflict(sql.ConflictColumns(columns...)).
//		Exec(ctx)
func (lrcb *LabelRelationshipCreateBulk) OnConflictColumns(columns ...string) *LabelRelationshipUpsertBulk {
	lrcb.conflict = append(lrcb.conflict, sql.ConflictColumns(columns...))
	return &LabelRelationshipUpsertBulk{
		create: lrcb,
	}
}

// LabelRelationshipUpsertBulk is the builder for "upsert"-ing
// a bulk of LabelRelationship nodes.
type LabelRelationshipUpsertBulk struct {
	create *LabelRelationshipCreateBulk
}

// UpdateNewValues updates the mutable fields using the new values that
// were set on create. Using this option is equivalent to using:
//
//	client.LabelRelationship.Create().
//		OnConflict(
//			sql.ResolveWithNewValues(),
//			sql.ResolveWith(func(u *sql.UpdateSet) {
//				u.SetIgnore(labelrelationship.FieldID)
//			}),
//		).
//		Exec(ctx)
func (u *LabelRelationshipUpsertBulk) UpdateNewValues() *LabelRelationshipUpsertBulk {
	u.create.conflict = append(u.create.conflict, sql.ResolveWithNewValues())
	u.create.conflict = append(u.create.conflict, sql.ResolveWith(func(s *sql.UpdateSet) {
		for _, b := range u.create.builders {
			if _, exists := b.mutation.ID(); exists {
				s.SetIgnore(labelrelationship.FieldID)
			}
			if _, exists := b.mutation.CreatedAt(); exists {
				s.SetIgnore(labelrelationship.FieldCreatedAt)
			}
		}
	}))
	return u
}

// Ignore sets each column to itself in case of conflict.
// Using this option is equivalent to using:
//
//	client.LabelRelationship.Create().
//		OnConflict(sql.ResolveWithIgnore()).
//		Exec(ctx)
func (u *LabelRelationshipUpsertBulk) Ignore() *LabelRelationshipUpsertBulk {
	u.create.conflict = append(u.create.conflict, sql.ResolveWithIgnore())
	return u
}

// DoNothing configures the conflict_action to `DO NOTHING`.
// Supported only by SQLite and PostgreSQL.
func (u *LabelRelationshipUpsertBulk) DoNothing() *LabelRelationshipUpsertBulk {
	u.create.conflict = append(u.create.conflict, sql.DoNothing())
	return u
}

// Update allows overriding fields `UPDATE` values. See the LabelRelationshipCreateBulk.OnConflict
// documentation for more info.
func (u *LabelRelationshipUpsertBulk) Update(set func(*LabelRelationshipUpsert)) *LabelRelationshipUpsertBulk {
	u.create.conflict = append(u.create.conflict, sql.ResolveWith(func(update *sql.UpdateSet) {
		set(&LabelRelationshipUpsert{UpdateSet: update})
	}))
	return u
}

// SetUpdatedAt sets the "updated_at" field.
func (u *LabelRelationshipUpsertBulk) SetUpdatedAt(v time.Time) *LabelRelationshipUpsertBulk {
	return u.Update(func(s *LabelRelationshipUpsert) {
		s.SetUpdatedAt(v)
	})
}

// UpdateUpdatedAt sets the "updated_at" field to the value that was provided on create.
func (u *LabelRelationshipUpsertBulk) UpdateUpdatedAt() *LabelRelationshipUpsertBulk {
	return u.Update(func(s *LabelRelationshipUpsert) {
		s.UpdateUpdatedAt()
	})
}

// SetStatus sets the "status" field.
func (u *LabelRelationshipUpsertBulk) SetStatus(v uint8) *LabelRelationshipUpsertBulk {
	return u.Update(func(s *LabelRelationshipUpsert) {
		s.SetStatus(v)
	})
}

// AddStatus adds v to the "status" field.
func (u *LabelRelationshipUpsertBulk) AddStatus(v uint8) *LabelRelationshipUpsertBulk {
	return u.Update(func(s *LabelRelationshipUpsert) {
		s.AddStatus(v)
	})
}

// UpdateStatus sets the "status" field to the value that was provided on create.
func (u *LabelRelationshipUpsertBulk) UpdateStatus() *LabelRelationshipUpsertBulk {
	return u.Update(func(s *LabelRelationshipUpsert) {
		s.UpdateStatus()
	})
}

// ClearStatus clears the value of the "status" field.
func (u *LabelRelationshipUpsertBulk) ClearStatus() *LabelRelationshipUpsertBulk {
	return u.Update(func(s *LabelRelationshipUpsert) {
		s.ClearStatus()
	})
}

// SetDeletedAt sets the "deleted_at" field.
func (u *LabelRelationshipUpsertBulk) SetDeletedAt(v time.Time) *LabelRelationshipUpsertBulk {
	return u.Update(func(s *LabelRelationshipUpsert) {
		s.SetDeletedAt(v)
	})
}

// UpdateDeletedAt sets the "deleted_at" field to the value that was provided on create.
func (u *LabelRelationshipUpsertBulk) UpdateDeletedAt() *LabelRelationshipUpsertBulk {
	return u.Update(func(s *LabelRelationshipUpsert) {
		s.UpdateDeletedAt()
	})
}

// ClearDeletedAt clears the value of the "deleted_at" field.
func (u *LabelRelationshipUpsertBulk) ClearDeletedAt() *LabelRelationshipUpsertBulk {
	return u.Update(func(s *LabelRelationshipUpsert) {
		s.ClearDeletedAt()
	})
}

// SetLabelID sets the "label_id" field.
func (u *LabelRelationshipUpsertBulk) SetLabelID(v uint64) *LabelRelationshipUpsertBulk {
	return u.Update(func(s *LabelRelationshipUpsert) {
		s.SetLabelID(v)
	})
}

// UpdateLabelID sets the "label_id" field to the value that was provided on create.
func (u *LabelRelationshipUpsertBulk) UpdateLabelID() *LabelRelationshipUpsertBulk {
	return u.Update(func(s *LabelRelationshipUpsert) {
		s.UpdateLabelID()
	})
}

// SetContactID sets the "contact_id" field.
func (u *LabelRelationshipUpsertBulk) SetContactID(v uint64) *LabelRelationshipUpsertBulk {
	return u.Update(func(s *LabelRelationshipUpsert) {
		s.SetContactID(v)
	})
}

// UpdateContactID sets the "contact_id" field to the value that was provided on create.
func (u *LabelRelationshipUpsertBulk) UpdateContactID() *LabelRelationshipUpsertBulk {
	return u.Update(func(s *LabelRelationshipUpsert) {
		s.UpdateContactID()
	})
}

// Exec executes the query.
func (u *LabelRelationshipUpsertBulk) Exec(ctx context.Context) error {
	if u.create.err != nil {
		return u.create.err
	}
	for i, b := range u.create.builders {
		if len(b.conflict) != 0 {
			return fmt.Errorf("ent: OnConflict was set for builder %d. Set it on the LabelRelationshipCreateBulk instead", i)
		}
	}
	if len(u.create.conflict) == 0 {
		return errors.New("ent: missing options for LabelRelationshipCreateBulk.OnConflict")
	}
	return u.create.Exec(ctx)
}

// ExecX is like Exec, but panics if an error occurs.
func (u *LabelRelationshipUpsertBulk) ExecX(ctx context.Context) {
	if err := u.create.Exec(ctx); err != nil {
		panic(err)
	}
}
