// Code generated by ent, DO NOT EDIT.

package server

import (
	"time"
	"wechat-api/ent/predicate"

	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
)

// ID filters vertices based on their ID field.
func ID(id uint64) predicate.Server {
	return predicate.Server(sql.FieldEQ(FieldID, id))
}

// IDEQ applies the EQ predicate on the ID field.
func IDEQ(id uint64) predicate.Server {
	return predicate.Server(sql.FieldEQ(FieldID, id))
}

// IDNEQ applies the NEQ predicate on the ID field.
func IDNEQ(id uint64) predicate.Server {
	return predicate.Server(sql.FieldNEQ(FieldID, id))
}

// IDIn applies the In predicate on the ID field.
func IDIn(ids ...uint64) predicate.Server {
	return predicate.Server(sql.FieldIn(FieldID, ids...))
}

// IDNotIn applies the NotIn predicate on the ID field.
func IDNotIn(ids ...uint64) predicate.Server {
	return predicate.Server(sql.FieldNotIn(FieldID, ids...))
}

// IDGT applies the GT predicate on the ID field.
func IDGT(id uint64) predicate.Server {
	return predicate.Server(sql.FieldGT(FieldID, id))
}

// IDGTE applies the GTE predicate on the ID field.
func IDGTE(id uint64) predicate.Server {
	return predicate.Server(sql.FieldGTE(FieldID, id))
}

// IDLT applies the LT predicate on the ID field.
func IDLT(id uint64) predicate.Server {
	return predicate.Server(sql.FieldLT(FieldID, id))
}

// IDLTE applies the LTE predicate on the ID field.
func IDLTE(id uint64) predicate.Server {
	return predicate.Server(sql.FieldLTE(FieldID, id))
}

// CreatedAt applies equality check predicate on the "created_at" field. It's identical to CreatedAtEQ.
func CreatedAt(v time.Time) predicate.Server {
	return predicate.Server(sql.FieldEQ(FieldCreatedAt, v))
}

// UpdatedAt applies equality check predicate on the "updated_at" field. It's identical to UpdatedAtEQ.
func UpdatedAt(v time.Time) predicate.Server {
	return predicate.Server(sql.FieldEQ(FieldUpdatedAt, v))
}

// Status applies equality check predicate on the "status" field. It's identical to StatusEQ.
func Status(v uint8) predicate.Server {
	return predicate.Server(sql.FieldEQ(FieldStatus, v))
}

// DeletedAt applies equality check predicate on the "deleted_at" field. It's identical to DeletedAtEQ.
func DeletedAt(v time.Time) predicate.Server {
	return predicate.Server(sql.FieldEQ(FieldDeletedAt, v))
}

// Name applies equality check predicate on the "name" field. It's identical to NameEQ.
func Name(v string) predicate.Server {
	return predicate.Server(sql.FieldEQ(FieldName, v))
}

// PublicIP applies equality check predicate on the "public_ip" field. It's identical to PublicIPEQ.
func PublicIP(v string) predicate.Server {
	return predicate.Server(sql.FieldEQ(FieldPublicIP, v))
}

// PrivateIP applies equality check predicate on the "private_ip" field. It's identical to PrivateIPEQ.
func PrivateIP(v string) predicate.Server {
	return predicate.Server(sql.FieldEQ(FieldPrivateIP, v))
}

// AdminPort applies equality check predicate on the "admin_port" field. It's identical to AdminPortEQ.
func AdminPort(v string) predicate.Server {
	return predicate.Server(sql.FieldEQ(FieldAdminPort, v))
}

// CreatedAtEQ applies the EQ predicate on the "created_at" field.
func CreatedAtEQ(v time.Time) predicate.Server {
	return predicate.Server(sql.FieldEQ(FieldCreatedAt, v))
}

// CreatedAtNEQ applies the NEQ predicate on the "created_at" field.
func CreatedAtNEQ(v time.Time) predicate.Server {
	return predicate.Server(sql.FieldNEQ(FieldCreatedAt, v))
}

// CreatedAtIn applies the In predicate on the "created_at" field.
func CreatedAtIn(vs ...time.Time) predicate.Server {
	return predicate.Server(sql.FieldIn(FieldCreatedAt, vs...))
}

// CreatedAtNotIn applies the NotIn predicate on the "created_at" field.
func CreatedAtNotIn(vs ...time.Time) predicate.Server {
	return predicate.Server(sql.FieldNotIn(FieldCreatedAt, vs...))
}

// CreatedAtGT applies the GT predicate on the "created_at" field.
func CreatedAtGT(v time.Time) predicate.Server {
	return predicate.Server(sql.FieldGT(FieldCreatedAt, v))
}

// CreatedAtGTE applies the GTE predicate on the "created_at" field.
func CreatedAtGTE(v time.Time) predicate.Server {
	return predicate.Server(sql.FieldGTE(FieldCreatedAt, v))
}

// CreatedAtLT applies the LT predicate on the "created_at" field.
func CreatedAtLT(v time.Time) predicate.Server {
	return predicate.Server(sql.FieldLT(FieldCreatedAt, v))
}

// CreatedAtLTE applies the LTE predicate on the "created_at" field.
func CreatedAtLTE(v time.Time) predicate.Server {
	return predicate.Server(sql.FieldLTE(FieldCreatedAt, v))
}

// UpdatedAtEQ applies the EQ predicate on the "updated_at" field.
func UpdatedAtEQ(v time.Time) predicate.Server {
	return predicate.Server(sql.FieldEQ(FieldUpdatedAt, v))
}

// UpdatedAtNEQ applies the NEQ predicate on the "updated_at" field.
func UpdatedAtNEQ(v time.Time) predicate.Server {
	return predicate.Server(sql.FieldNEQ(FieldUpdatedAt, v))
}

// UpdatedAtIn applies the In predicate on the "updated_at" field.
func UpdatedAtIn(vs ...time.Time) predicate.Server {
	return predicate.Server(sql.FieldIn(FieldUpdatedAt, vs...))
}

// UpdatedAtNotIn applies the NotIn predicate on the "updated_at" field.
func UpdatedAtNotIn(vs ...time.Time) predicate.Server {
	return predicate.Server(sql.FieldNotIn(FieldUpdatedAt, vs...))
}

// UpdatedAtGT applies the GT predicate on the "updated_at" field.
func UpdatedAtGT(v time.Time) predicate.Server {
	return predicate.Server(sql.FieldGT(FieldUpdatedAt, v))
}

// UpdatedAtGTE applies the GTE predicate on the "updated_at" field.
func UpdatedAtGTE(v time.Time) predicate.Server {
	return predicate.Server(sql.FieldGTE(FieldUpdatedAt, v))
}

// UpdatedAtLT applies the LT predicate on the "updated_at" field.
func UpdatedAtLT(v time.Time) predicate.Server {
	return predicate.Server(sql.FieldLT(FieldUpdatedAt, v))
}

// UpdatedAtLTE applies the LTE predicate on the "updated_at" field.
func UpdatedAtLTE(v time.Time) predicate.Server {
	return predicate.Server(sql.FieldLTE(FieldUpdatedAt, v))
}

// StatusEQ applies the EQ predicate on the "status" field.
func StatusEQ(v uint8) predicate.Server {
	return predicate.Server(sql.FieldEQ(FieldStatus, v))
}

// StatusNEQ applies the NEQ predicate on the "status" field.
func StatusNEQ(v uint8) predicate.Server {
	return predicate.Server(sql.FieldNEQ(FieldStatus, v))
}

// StatusIn applies the In predicate on the "status" field.
func StatusIn(vs ...uint8) predicate.Server {
	return predicate.Server(sql.FieldIn(FieldStatus, vs...))
}

// StatusNotIn applies the NotIn predicate on the "status" field.
func StatusNotIn(vs ...uint8) predicate.Server {
	return predicate.Server(sql.FieldNotIn(FieldStatus, vs...))
}

// StatusGT applies the GT predicate on the "status" field.
func StatusGT(v uint8) predicate.Server {
	return predicate.Server(sql.FieldGT(FieldStatus, v))
}

// StatusGTE applies the GTE predicate on the "status" field.
func StatusGTE(v uint8) predicate.Server {
	return predicate.Server(sql.FieldGTE(FieldStatus, v))
}

// StatusLT applies the LT predicate on the "status" field.
func StatusLT(v uint8) predicate.Server {
	return predicate.Server(sql.FieldLT(FieldStatus, v))
}

// StatusLTE applies the LTE predicate on the "status" field.
func StatusLTE(v uint8) predicate.Server {
	return predicate.Server(sql.FieldLTE(FieldStatus, v))
}

// StatusIsNil applies the IsNil predicate on the "status" field.
func StatusIsNil() predicate.Server {
	return predicate.Server(sql.FieldIsNull(FieldStatus))
}

// StatusNotNil applies the NotNil predicate on the "status" field.
func StatusNotNil() predicate.Server {
	return predicate.Server(sql.FieldNotNull(FieldStatus))
}

// DeletedAtEQ applies the EQ predicate on the "deleted_at" field.
func DeletedAtEQ(v time.Time) predicate.Server {
	return predicate.Server(sql.FieldEQ(FieldDeletedAt, v))
}

// DeletedAtNEQ applies the NEQ predicate on the "deleted_at" field.
func DeletedAtNEQ(v time.Time) predicate.Server {
	return predicate.Server(sql.FieldNEQ(FieldDeletedAt, v))
}

// DeletedAtIn applies the In predicate on the "deleted_at" field.
func DeletedAtIn(vs ...time.Time) predicate.Server {
	return predicate.Server(sql.FieldIn(FieldDeletedAt, vs...))
}

// DeletedAtNotIn applies the NotIn predicate on the "deleted_at" field.
func DeletedAtNotIn(vs ...time.Time) predicate.Server {
	return predicate.Server(sql.FieldNotIn(FieldDeletedAt, vs...))
}

// DeletedAtGT applies the GT predicate on the "deleted_at" field.
func DeletedAtGT(v time.Time) predicate.Server {
	return predicate.Server(sql.FieldGT(FieldDeletedAt, v))
}

// DeletedAtGTE applies the GTE predicate on the "deleted_at" field.
func DeletedAtGTE(v time.Time) predicate.Server {
	return predicate.Server(sql.FieldGTE(FieldDeletedAt, v))
}

// DeletedAtLT applies the LT predicate on the "deleted_at" field.
func DeletedAtLT(v time.Time) predicate.Server {
	return predicate.Server(sql.FieldLT(FieldDeletedAt, v))
}

// DeletedAtLTE applies the LTE predicate on the "deleted_at" field.
func DeletedAtLTE(v time.Time) predicate.Server {
	return predicate.Server(sql.FieldLTE(FieldDeletedAt, v))
}

// DeletedAtIsNil applies the IsNil predicate on the "deleted_at" field.
func DeletedAtIsNil() predicate.Server {
	return predicate.Server(sql.FieldIsNull(FieldDeletedAt))
}

// DeletedAtNotNil applies the NotNil predicate on the "deleted_at" field.
func DeletedAtNotNil() predicate.Server {
	return predicate.Server(sql.FieldNotNull(FieldDeletedAt))
}

// NameEQ applies the EQ predicate on the "name" field.
func NameEQ(v string) predicate.Server {
	return predicate.Server(sql.FieldEQ(FieldName, v))
}

// NameNEQ applies the NEQ predicate on the "name" field.
func NameNEQ(v string) predicate.Server {
	return predicate.Server(sql.FieldNEQ(FieldName, v))
}

// NameIn applies the In predicate on the "name" field.
func NameIn(vs ...string) predicate.Server {
	return predicate.Server(sql.FieldIn(FieldName, vs...))
}

// NameNotIn applies the NotIn predicate on the "name" field.
func NameNotIn(vs ...string) predicate.Server {
	return predicate.Server(sql.FieldNotIn(FieldName, vs...))
}

// NameGT applies the GT predicate on the "name" field.
func NameGT(v string) predicate.Server {
	return predicate.Server(sql.FieldGT(FieldName, v))
}

// NameGTE applies the GTE predicate on the "name" field.
func NameGTE(v string) predicate.Server {
	return predicate.Server(sql.FieldGTE(FieldName, v))
}

// NameLT applies the LT predicate on the "name" field.
func NameLT(v string) predicate.Server {
	return predicate.Server(sql.FieldLT(FieldName, v))
}

// NameLTE applies the LTE predicate on the "name" field.
func NameLTE(v string) predicate.Server {
	return predicate.Server(sql.FieldLTE(FieldName, v))
}

// NameContains applies the Contains predicate on the "name" field.
func NameContains(v string) predicate.Server {
	return predicate.Server(sql.FieldContains(FieldName, v))
}

// NameHasPrefix applies the HasPrefix predicate on the "name" field.
func NameHasPrefix(v string) predicate.Server {
	return predicate.Server(sql.FieldHasPrefix(FieldName, v))
}

// NameHasSuffix applies the HasSuffix predicate on the "name" field.
func NameHasSuffix(v string) predicate.Server {
	return predicate.Server(sql.FieldHasSuffix(FieldName, v))
}

// NameEqualFold applies the EqualFold predicate on the "name" field.
func NameEqualFold(v string) predicate.Server {
	return predicate.Server(sql.FieldEqualFold(FieldName, v))
}

// NameContainsFold applies the ContainsFold predicate on the "name" field.
func NameContainsFold(v string) predicate.Server {
	return predicate.Server(sql.FieldContainsFold(FieldName, v))
}

// PublicIPEQ applies the EQ predicate on the "public_ip" field.
func PublicIPEQ(v string) predicate.Server {
	return predicate.Server(sql.FieldEQ(FieldPublicIP, v))
}

// PublicIPNEQ applies the NEQ predicate on the "public_ip" field.
func PublicIPNEQ(v string) predicate.Server {
	return predicate.Server(sql.FieldNEQ(FieldPublicIP, v))
}

// PublicIPIn applies the In predicate on the "public_ip" field.
func PublicIPIn(vs ...string) predicate.Server {
	return predicate.Server(sql.FieldIn(FieldPublicIP, vs...))
}

// PublicIPNotIn applies the NotIn predicate on the "public_ip" field.
func PublicIPNotIn(vs ...string) predicate.Server {
	return predicate.Server(sql.FieldNotIn(FieldPublicIP, vs...))
}

// PublicIPGT applies the GT predicate on the "public_ip" field.
func PublicIPGT(v string) predicate.Server {
	return predicate.Server(sql.FieldGT(FieldPublicIP, v))
}

// PublicIPGTE applies the GTE predicate on the "public_ip" field.
func PublicIPGTE(v string) predicate.Server {
	return predicate.Server(sql.FieldGTE(FieldPublicIP, v))
}

// PublicIPLT applies the LT predicate on the "public_ip" field.
func PublicIPLT(v string) predicate.Server {
	return predicate.Server(sql.FieldLT(FieldPublicIP, v))
}

// PublicIPLTE applies the LTE predicate on the "public_ip" field.
func PublicIPLTE(v string) predicate.Server {
	return predicate.Server(sql.FieldLTE(FieldPublicIP, v))
}

// PublicIPContains applies the Contains predicate on the "public_ip" field.
func PublicIPContains(v string) predicate.Server {
	return predicate.Server(sql.FieldContains(FieldPublicIP, v))
}

// PublicIPHasPrefix applies the HasPrefix predicate on the "public_ip" field.
func PublicIPHasPrefix(v string) predicate.Server {
	return predicate.Server(sql.FieldHasPrefix(FieldPublicIP, v))
}

// PublicIPHasSuffix applies the HasSuffix predicate on the "public_ip" field.
func PublicIPHasSuffix(v string) predicate.Server {
	return predicate.Server(sql.FieldHasSuffix(FieldPublicIP, v))
}

// PublicIPEqualFold applies the EqualFold predicate on the "public_ip" field.
func PublicIPEqualFold(v string) predicate.Server {
	return predicate.Server(sql.FieldEqualFold(FieldPublicIP, v))
}

// PublicIPContainsFold applies the ContainsFold predicate on the "public_ip" field.
func PublicIPContainsFold(v string) predicate.Server {
	return predicate.Server(sql.FieldContainsFold(FieldPublicIP, v))
}

// PrivateIPEQ applies the EQ predicate on the "private_ip" field.
func PrivateIPEQ(v string) predicate.Server {
	return predicate.Server(sql.FieldEQ(FieldPrivateIP, v))
}

// PrivateIPNEQ applies the NEQ predicate on the "private_ip" field.
func PrivateIPNEQ(v string) predicate.Server {
	return predicate.Server(sql.FieldNEQ(FieldPrivateIP, v))
}

// PrivateIPIn applies the In predicate on the "private_ip" field.
func PrivateIPIn(vs ...string) predicate.Server {
	return predicate.Server(sql.FieldIn(FieldPrivateIP, vs...))
}

// PrivateIPNotIn applies the NotIn predicate on the "private_ip" field.
func PrivateIPNotIn(vs ...string) predicate.Server {
	return predicate.Server(sql.FieldNotIn(FieldPrivateIP, vs...))
}

// PrivateIPGT applies the GT predicate on the "private_ip" field.
func PrivateIPGT(v string) predicate.Server {
	return predicate.Server(sql.FieldGT(FieldPrivateIP, v))
}

// PrivateIPGTE applies the GTE predicate on the "private_ip" field.
func PrivateIPGTE(v string) predicate.Server {
	return predicate.Server(sql.FieldGTE(FieldPrivateIP, v))
}

// PrivateIPLT applies the LT predicate on the "private_ip" field.
func PrivateIPLT(v string) predicate.Server {
	return predicate.Server(sql.FieldLT(FieldPrivateIP, v))
}

// PrivateIPLTE applies the LTE predicate on the "private_ip" field.
func PrivateIPLTE(v string) predicate.Server {
	return predicate.Server(sql.FieldLTE(FieldPrivateIP, v))
}

// PrivateIPContains applies the Contains predicate on the "private_ip" field.
func PrivateIPContains(v string) predicate.Server {
	return predicate.Server(sql.FieldContains(FieldPrivateIP, v))
}

// PrivateIPHasPrefix applies the HasPrefix predicate on the "private_ip" field.
func PrivateIPHasPrefix(v string) predicate.Server {
	return predicate.Server(sql.FieldHasPrefix(FieldPrivateIP, v))
}

// PrivateIPHasSuffix applies the HasSuffix predicate on the "private_ip" field.
func PrivateIPHasSuffix(v string) predicate.Server {
	return predicate.Server(sql.FieldHasSuffix(FieldPrivateIP, v))
}

// PrivateIPEqualFold applies the EqualFold predicate on the "private_ip" field.
func PrivateIPEqualFold(v string) predicate.Server {
	return predicate.Server(sql.FieldEqualFold(FieldPrivateIP, v))
}

// PrivateIPContainsFold applies the ContainsFold predicate on the "private_ip" field.
func PrivateIPContainsFold(v string) predicate.Server {
	return predicate.Server(sql.FieldContainsFold(FieldPrivateIP, v))
}

// AdminPortEQ applies the EQ predicate on the "admin_port" field.
func AdminPortEQ(v string) predicate.Server {
	return predicate.Server(sql.FieldEQ(FieldAdminPort, v))
}

// AdminPortNEQ applies the NEQ predicate on the "admin_port" field.
func AdminPortNEQ(v string) predicate.Server {
	return predicate.Server(sql.FieldNEQ(FieldAdminPort, v))
}

// AdminPortIn applies the In predicate on the "admin_port" field.
func AdminPortIn(vs ...string) predicate.Server {
	return predicate.Server(sql.FieldIn(FieldAdminPort, vs...))
}

// AdminPortNotIn applies the NotIn predicate on the "admin_port" field.
func AdminPortNotIn(vs ...string) predicate.Server {
	return predicate.Server(sql.FieldNotIn(FieldAdminPort, vs...))
}

// AdminPortGT applies the GT predicate on the "admin_port" field.
func AdminPortGT(v string) predicate.Server {
	return predicate.Server(sql.FieldGT(FieldAdminPort, v))
}

// AdminPortGTE applies the GTE predicate on the "admin_port" field.
func AdminPortGTE(v string) predicate.Server {
	return predicate.Server(sql.FieldGTE(FieldAdminPort, v))
}

// AdminPortLT applies the LT predicate on the "admin_port" field.
func AdminPortLT(v string) predicate.Server {
	return predicate.Server(sql.FieldLT(FieldAdminPort, v))
}

// AdminPortLTE applies the LTE predicate on the "admin_port" field.
func AdminPortLTE(v string) predicate.Server {
	return predicate.Server(sql.FieldLTE(FieldAdminPort, v))
}

// AdminPortContains applies the Contains predicate on the "admin_port" field.
func AdminPortContains(v string) predicate.Server {
	return predicate.Server(sql.FieldContains(FieldAdminPort, v))
}

// AdminPortHasPrefix applies the HasPrefix predicate on the "admin_port" field.
func AdminPortHasPrefix(v string) predicate.Server {
	return predicate.Server(sql.FieldHasPrefix(FieldAdminPort, v))
}

// AdminPortHasSuffix applies the HasSuffix predicate on the "admin_port" field.
func AdminPortHasSuffix(v string) predicate.Server {
	return predicate.Server(sql.FieldHasSuffix(FieldAdminPort, v))
}

// AdminPortEqualFold applies the EqualFold predicate on the "admin_port" field.
func AdminPortEqualFold(v string) predicate.Server {
	return predicate.Server(sql.FieldEqualFold(FieldAdminPort, v))
}

// AdminPortContainsFold applies the ContainsFold predicate on the "admin_port" field.
func AdminPortContainsFold(v string) predicate.Server {
	return predicate.Server(sql.FieldContainsFold(FieldAdminPort, v))
}

// HasWxs applies the HasEdge predicate on the "wxs" edge.
func HasWxs() predicate.Server {
	return predicate.Server(func(s *sql.Selector) {
		step := sqlgraph.NewStep(
			sqlgraph.From(Table, FieldID),
			sqlgraph.Edge(sqlgraph.O2M, false, WxsTable, WxsColumn),
		)
		sqlgraph.HasNeighbors(s, step)
	})
}

// HasWxsWith applies the HasEdge predicate on the "wxs" edge with a given conditions (other predicates).
func HasWxsWith(preds ...predicate.Wx) predicate.Server {
	return predicate.Server(func(s *sql.Selector) {
		step := newWxsStep()
		sqlgraph.HasNeighborsWith(s, step, func(s *sql.Selector) {
			for _, p := range preds {
				p(s)
			}
		})
	})
}

// And groups predicates with the AND operator between them.
func And(predicates ...predicate.Server) predicate.Server {
	return predicate.Server(sql.AndPredicates(predicates...))
}

// Or groups predicates with the OR operator between them.
func Or(predicates ...predicate.Server) predicate.Server {
	return predicate.Server(sql.OrPredicates(predicates...))
}

// Not applies the not operator on the given predicate.
func Not(p predicate.Server) predicate.Server {
	return predicate.Server(sql.NotPredicates(p))
}
