// Code generated by ent, DO NOT EDIT.

package sopnode

import (
	"time"
	"wechat-api/ent/predicate"

	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
)

// ID filters vertices based on their ID field.
func ID(id uint64) predicate.SopNode {
	return predicate.SopNode(sql.FieldEQ(FieldID, id))
}

// IDEQ applies the EQ predicate on the ID field.
func IDEQ(id uint64) predicate.SopNode {
	return predicate.SopNode(sql.FieldEQ(FieldID, id))
}

// IDNEQ applies the NEQ predicate on the ID field.
func IDNEQ(id uint64) predicate.SopNode {
	return predicate.SopNode(sql.FieldNEQ(FieldID, id))
}

// IDIn applies the In predicate on the ID field.
func IDIn(ids ...uint64) predicate.SopNode {
	return predicate.SopNode(sql.FieldIn(FieldID, ids...))
}

// IDNotIn applies the NotIn predicate on the ID field.
func IDNotIn(ids ...uint64) predicate.SopNode {
	return predicate.SopNode(sql.FieldNotIn(FieldID, ids...))
}

// IDGT applies the GT predicate on the ID field.
func IDGT(id uint64) predicate.SopNode {
	return predicate.SopNode(sql.FieldGT(FieldID, id))
}

// IDGTE applies the GTE predicate on the ID field.
func IDGTE(id uint64) predicate.SopNode {
	return predicate.SopNode(sql.FieldGTE(FieldID, id))
}

// IDLT applies the LT predicate on the ID field.
func IDLT(id uint64) predicate.SopNode {
	return predicate.SopNode(sql.FieldLT(FieldID, id))
}

// IDLTE applies the LTE predicate on the ID field.
func IDLTE(id uint64) predicate.SopNode {
	return predicate.SopNode(sql.FieldLTE(FieldID, id))
}

// CreatedAt applies equality check predicate on the "created_at" field. It's identical to CreatedAtEQ.
func CreatedAt(v time.Time) predicate.SopNode {
	return predicate.SopNode(sql.FieldEQ(FieldCreatedAt, v))
}

// UpdatedAt applies equality check predicate on the "updated_at" field. It's identical to UpdatedAtEQ.
func UpdatedAt(v time.Time) predicate.SopNode {
	return predicate.SopNode(sql.FieldEQ(FieldUpdatedAt, v))
}

// Status applies equality check predicate on the "status" field. It's identical to StatusEQ.
func Status(v uint8) predicate.SopNode {
	return predicate.SopNode(sql.FieldEQ(FieldStatus, v))
}

// DeletedAt applies equality check predicate on the "deleted_at" field. It's identical to DeletedAtEQ.
func DeletedAt(v time.Time) predicate.SopNode {
	return predicate.SopNode(sql.FieldEQ(FieldDeletedAt, v))
}

// StageID applies equality check predicate on the "stage_id" field. It's identical to StageIDEQ.
func StageID(v uint64) predicate.SopNode {
	return predicate.SopNode(sql.FieldEQ(FieldStageID, v))
}

// ParentID applies equality check predicate on the "parent_id" field. It's identical to ParentIDEQ.
func ParentID(v uint64) predicate.SopNode {
	return predicate.SopNode(sql.FieldEQ(FieldParentID, v))
}

// Name applies equality check predicate on the "name" field. It's identical to NameEQ.
func Name(v string) predicate.SopNode {
	return predicate.SopNode(sql.FieldEQ(FieldName, v))
}

// ConditionType applies equality check predicate on the "condition_type" field. It's identical to ConditionTypeEQ.
func ConditionType(v int) predicate.SopNode {
	return predicate.SopNode(sql.FieldEQ(FieldConditionType, v))
}

// CreatedAtEQ applies the EQ predicate on the "created_at" field.
func CreatedAtEQ(v time.Time) predicate.SopNode {
	return predicate.SopNode(sql.FieldEQ(FieldCreatedAt, v))
}

// CreatedAtNEQ applies the NEQ predicate on the "created_at" field.
func CreatedAtNEQ(v time.Time) predicate.SopNode {
	return predicate.SopNode(sql.FieldNEQ(FieldCreatedAt, v))
}

// CreatedAtIn applies the In predicate on the "created_at" field.
func CreatedAtIn(vs ...time.Time) predicate.SopNode {
	return predicate.SopNode(sql.FieldIn(FieldCreatedAt, vs...))
}

// CreatedAtNotIn applies the NotIn predicate on the "created_at" field.
func CreatedAtNotIn(vs ...time.Time) predicate.SopNode {
	return predicate.SopNode(sql.FieldNotIn(FieldCreatedAt, vs...))
}

// CreatedAtGT applies the GT predicate on the "created_at" field.
func CreatedAtGT(v time.Time) predicate.SopNode {
	return predicate.SopNode(sql.FieldGT(FieldCreatedAt, v))
}

// CreatedAtGTE applies the GTE predicate on the "created_at" field.
func CreatedAtGTE(v time.Time) predicate.SopNode {
	return predicate.SopNode(sql.FieldGTE(FieldCreatedAt, v))
}

// CreatedAtLT applies the LT predicate on the "created_at" field.
func CreatedAtLT(v time.Time) predicate.SopNode {
	return predicate.SopNode(sql.FieldLT(FieldCreatedAt, v))
}

// CreatedAtLTE applies the LTE predicate on the "created_at" field.
func CreatedAtLTE(v time.Time) predicate.SopNode {
	return predicate.SopNode(sql.FieldLTE(FieldCreatedAt, v))
}

// UpdatedAtEQ applies the EQ predicate on the "updated_at" field.
func UpdatedAtEQ(v time.Time) predicate.SopNode {
	return predicate.SopNode(sql.FieldEQ(FieldUpdatedAt, v))
}

// UpdatedAtNEQ applies the NEQ predicate on the "updated_at" field.
func UpdatedAtNEQ(v time.Time) predicate.SopNode {
	return predicate.SopNode(sql.FieldNEQ(FieldUpdatedAt, v))
}

// UpdatedAtIn applies the In predicate on the "updated_at" field.
func UpdatedAtIn(vs ...time.Time) predicate.SopNode {
	return predicate.SopNode(sql.FieldIn(FieldUpdatedAt, vs...))
}

// UpdatedAtNotIn applies the NotIn predicate on the "updated_at" field.
func UpdatedAtNotIn(vs ...time.Time) predicate.SopNode {
	return predicate.SopNode(sql.FieldNotIn(FieldUpdatedAt, vs...))
}

// UpdatedAtGT applies the GT predicate on the "updated_at" field.
func UpdatedAtGT(v time.Time) predicate.SopNode {
	return predicate.SopNode(sql.FieldGT(FieldUpdatedAt, v))
}

// UpdatedAtGTE applies the GTE predicate on the "updated_at" field.
func UpdatedAtGTE(v time.Time) predicate.SopNode {
	return predicate.SopNode(sql.FieldGTE(FieldUpdatedAt, v))
}

// UpdatedAtLT applies the LT predicate on the "updated_at" field.
func UpdatedAtLT(v time.Time) predicate.SopNode {
	return predicate.SopNode(sql.FieldLT(FieldUpdatedAt, v))
}

// UpdatedAtLTE applies the LTE predicate on the "updated_at" field.
func UpdatedAtLTE(v time.Time) predicate.SopNode {
	return predicate.SopNode(sql.FieldLTE(FieldUpdatedAt, v))
}

// StatusEQ applies the EQ predicate on the "status" field.
func StatusEQ(v uint8) predicate.SopNode {
	return predicate.SopNode(sql.FieldEQ(FieldStatus, v))
}

// StatusNEQ applies the NEQ predicate on the "status" field.
func StatusNEQ(v uint8) predicate.SopNode {
	return predicate.SopNode(sql.FieldNEQ(FieldStatus, v))
}

// StatusIn applies the In predicate on the "status" field.
func StatusIn(vs ...uint8) predicate.SopNode {
	return predicate.SopNode(sql.FieldIn(FieldStatus, vs...))
}

// StatusNotIn applies the NotIn predicate on the "status" field.
func StatusNotIn(vs ...uint8) predicate.SopNode {
	return predicate.SopNode(sql.FieldNotIn(FieldStatus, vs...))
}

// StatusGT applies the GT predicate on the "status" field.
func StatusGT(v uint8) predicate.SopNode {
	return predicate.SopNode(sql.FieldGT(FieldStatus, v))
}

// StatusGTE applies the GTE predicate on the "status" field.
func StatusGTE(v uint8) predicate.SopNode {
	return predicate.SopNode(sql.FieldGTE(FieldStatus, v))
}

// StatusLT applies the LT predicate on the "status" field.
func StatusLT(v uint8) predicate.SopNode {
	return predicate.SopNode(sql.FieldLT(FieldStatus, v))
}

// StatusLTE applies the LTE predicate on the "status" field.
func StatusLTE(v uint8) predicate.SopNode {
	return predicate.SopNode(sql.FieldLTE(FieldStatus, v))
}

// StatusIsNil applies the IsNil predicate on the "status" field.
func StatusIsNil() predicate.SopNode {
	return predicate.SopNode(sql.FieldIsNull(FieldStatus))
}

// StatusNotNil applies the NotNil predicate on the "status" field.
func StatusNotNil() predicate.SopNode {
	return predicate.SopNode(sql.FieldNotNull(FieldStatus))
}

// DeletedAtEQ applies the EQ predicate on the "deleted_at" field.
func DeletedAtEQ(v time.Time) predicate.SopNode {
	return predicate.SopNode(sql.FieldEQ(FieldDeletedAt, v))
}

// DeletedAtNEQ applies the NEQ predicate on the "deleted_at" field.
func DeletedAtNEQ(v time.Time) predicate.SopNode {
	return predicate.SopNode(sql.FieldNEQ(FieldDeletedAt, v))
}

// DeletedAtIn applies the In predicate on the "deleted_at" field.
func DeletedAtIn(vs ...time.Time) predicate.SopNode {
	return predicate.SopNode(sql.FieldIn(FieldDeletedAt, vs...))
}

// DeletedAtNotIn applies the NotIn predicate on the "deleted_at" field.
func DeletedAtNotIn(vs ...time.Time) predicate.SopNode {
	return predicate.SopNode(sql.FieldNotIn(FieldDeletedAt, vs...))
}

// DeletedAtGT applies the GT predicate on the "deleted_at" field.
func DeletedAtGT(v time.Time) predicate.SopNode {
	return predicate.SopNode(sql.FieldGT(FieldDeletedAt, v))
}

// DeletedAtGTE applies the GTE predicate on the "deleted_at" field.
func DeletedAtGTE(v time.Time) predicate.SopNode {
	return predicate.SopNode(sql.FieldGTE(FieldDeletedAt, v))
}

// DeletedAtLT applies the LT predicate on the "deleted_at" field.
func DeletedAtLT(v time.Time) predicate.SopNode {
	return predicate.SopNode(sql.FieldLT(FieldDeletedAt, v))
}

// DeletedAtLTE applies the LTE predicate on the "deleted_at" field.
func DeletedAtLTE(v time.Time) predicate.SopNode {
	return predicate.SopNode(sql.FieldLTE(FieldDeletedAt, v))
}

// DeletedAtIsNil applies the IsNil predicate on the "deleted_at" field.
func DeletedAtIsNil() predicate.SopNode {
	return predicate.SopNode(sql.FieldIsNull(FieldDeletedAt))
}

// DeletedAtNotNil applies the NotNil predicate on the "deleted_at" field.
func DeletedAtNotNil() predicate.SopNode {
	return predicate.SopNode(sql.FieldNotNull(FieldDeletedAt))
}

// StageIDEQ applies the EQ predicate on the "stage_id" field.
func StageIDEQ(v uint64) predicate.SopNode {
	return predicate.SopNode(sql.FieldEQ(FieldStageID, v))
}

// StageIDNEQ applies the NEQ predicate on the "stage_id" field.
func StageIDNEQ(v uint64) predicate.SopNode {
	return predicate.SopNode(sql.FieldNEQ(FieldStageID, v))
}

// StageIDIn applies the In predicate on the "stage_id" field.
func StageIDIn(vs ...uint64) predicate.SopNode {
	return predicate.SopNode(sql.FieldIn(FieldStageID, vs...))
}

// StageIDNotIn applies the NotIn predicate on the "stage_id" field.
func StageIDNotIn(vs ...uint64) predicate.SopNode {
	return predicate.SopNode(sql.FieldNotIn(FieldStageID, vs...))
}

// ParentIDEQ applies the EQ predicate on the "parent_id" field.
func ParentIDEQ(v uint64) predicate.SopNode {
	return predicate.SopNode(sql.FieldEQ(FieldParentID, v))
}

// ParentIDNEQ applies the NEQ predicate on the "parent_id" field.
func ParentIDNEQ(v uint64) predicate.SopNode {
	return predicate.SopNode(sql.FieldNEQ(FieldParentID, v))
}

// ParentIDIn applies the In predicate on the "parent_id" field.
func ParentIDIn(vs ...uint64) predicate.SopNode {
	return predicate.SopNode(sql.FieldIn(FieldParentID, vs...))
}

// ParentIDNotIn applies the NotIn predicate on the "parent_id" field.
func ParentIDNotIn(vs ...uint64) predicate.SopNode {
	return predicate.SopNode(sql.FieldNotIn(FieldParentID, vs...))
}

// ParentIDGT applies the GT predicate on the "parent_id" field.
func ParentIDGT(v uint64) predicate.SopNode {
	return predicate.SopNode(sql.FieldGT(FieldParentID, v))
}

// ParentIDGTE applies the GTE predicate on the "parent_id" field.
func ParentIDGTE(v uint64) predicate.SopNode {
	return predicate.SopNode(sql.FieldGTE(FieldParentID, v))
}

// ParentIDLT applies the LT predicate on the "parent_id" field.
func ParentIDLT(v uint64) predicate.SopNode {
	return predicate.SopNode(sql.FieldLT(FieldParentID, v))
}

// ParentIDLTE applies the LTE predicate on the "parent_id" field.
func ParentIDLTE(v uint64) predicate.SopNode {
	return predicate.SopNode(sql.FieldLTE(FieldParentID, v))
}

// NameEQ applies the EQ predicate on the "name" field.
func NameEQ(v string) predicate.SopNode {
	return predicate.SopNode(sql.FieldEQ(FieldName, v))
}

// NameNEQ applies the NEQ predicate on the "name" field.
func NameNEQ(v string) predicate.SopNode {
	return predicate.SopNode(sql.FieldNEQ(FieldName, v))
}

// NameIn applies the In predicate on the "name" field.
func NameIn(vs ...string) predicate.SopNode {
	return predicate.SopNode(sql.FieldIn(FieldName, vs...))
}

// NameNotIn applies the NotIn predicate on the "name" field.
func NameNotIn(vs ...string) predicate.SopNode {
	return predicate.SopNode(sql.FieldNotIn(FieldName, vs...))
}

// NameGT applies the GT predicate on the "name" field.
func NameGT(v string) predicate.SopNode {
	return predicate.SopNode(sql.FieldGT(FieldName, v))
}

// NameGTE applies the GTE predicate on the "name" field.
func NameGTE(v string) predicate.SopNode {
	return predicate.SopNode(sql.FieldGTE(FieldName, v))
}

// NameLT applies the LT predicate on the "name" field.
func NameLT(v string) predicate.SopNode {
	return predicate.SopNode(sql.FieldLT(FieldName, v))
}

// NameLTE applies the LTE predicate on the "name" field.
func NameLTE(v string) predicate.SopNode {
	return predicate.SopNode(sql.FieldLTE(FieldName, v))
}

// NameContains applies the Contains predicate on the "name" field.
func NameContains(v string) predicate.SopNode {
	return predicate.SopNode(sql.FieldContains(FieldName, v))
}

// NameHasPrefix applies the HasPrefix predicate on the "name" field.
func NameHasPrefix(v string) predicate.SopNode {
	return predicate.SopNode(sql.FieldHasPrefix(FieldName, v))
}

// NameHasSuffix applies the HasSuffix predicate on the "name" field.
func NameHasSuffix(v string) predicate.SopNode {
	return predicate.SopNode(sql.FieldHasSuffix(FieldName, v))
}

// NameEqualFold applies the EqualFold predicate on the "name" field.
func NameEqualFold(v string) predicate.SopNode {
	return predicate.SopNode(sql.FieldEqualFold(FieldName, v))
}

// NameContainsFold applies the ContainsFold predicate on the "name" field.
func NameContainsFold(v string) predicate.SopNode {
	return predicate.SopNode(sql.FieldContainsFold(FieldName, v))
}

// ConditionTypeEQ applies the EQ predicate on the "condition_type" field.
func ConditionTypeEQ(v int) predicate.SopNode {
	return predicate.SopNode(sql.FieldEQ(FieldConditionType, v))
}

// ConditionTypeNEQ applies the NEQ predicate on the "condition_type" field.
func ConditionTypeNEQ(v int) predicate.SopNode {
	return predicate.SopNode(sql.FieldNEQ(FieldConditionType, v))
}

// ConditionTypeIn applies the In predicate on the "condition_type" field.
func ConditionTypeIn(vs ...int) predicate.SopNode {
	return predicate.SopNode(sql.FieldIn(FieldConditionType, vs...))
}

// ConditionTypeNotIn applies the NotIn predicate on the "condition_type" field.
func ConditionTypeNotIn(vs ...int) predicate.SopNode {
	return predicate.SopNode(sql.FieldNotIn(FieldConditionType, vs...))
}

// ConditionTypeGT applies the GT predicate on the "condition_type" field.
func ConditionTypeGT(v int) predicate.SopNode {
	return predicate.SopNode(sql.FieldGT(FieldConditionType, v))
}

// ConditionTypeGTE applies the GTE predicate on the "condition_type" field.
func ConditionTypeGTE(v int) predicate.SopNode {
	return predicate.SopNode(sql.FieldGTE(FieldConditionType, v))
}

// ConditionTypeLT applies the LT predicate on the "condition_type" field.
func ConditionTypeLT(v int) predicate.SopNode {
	return predicate.SopNode(sql.FieldLT(FieldConditionType, v))
}

// ConditionTypeLTE applies the LTE predicate on the "condition_type" field.
func ConditionTypeLTE(v int) predicate.SopNode {
	return predicate.SopNode(sql.FieldLTE(FieldConditionType, v))
}

// ConditionListIsNil applies the IsNil predicate on the "condition_list" field.
func ConditionListIsNil() predicate.SopNode {
	return predicate.SopNode(sql.FieldIsNull(FieldConditionList))
}

// ConditionListNotNil applies the NotNil predicate on the "condition_list" field.
func ConditionListNotNil() predicate.SopNode {
	return predicate.SopNode(sql.FieldNotNull(FieldConditionList))
}

// ActionMessageIsNil applies the IsNil predicate on the "action_message" field.
func ActionMessageIsNil() predicate.SopNode {
	return predicate.SopNode(sql.FieldIsNull(FieldActionMessage))
}

// ActionMessageNotNil applies the NotNil predicate on the "action_message" field.
func ActionMessageNotNil() predicate.SopNode {
	return predicate.SopNode(sql.FieldNotNull(FieldActionMessage))
}

// ActionLabelIsNil applies the IsNil predicate on the "action_label" field.
func ActionLabelIsNil() predicate.SopNode {
	return predicate.SopNode(sql.FieldIsNull(FieldActionLabel))
}

// ActionLabelNotNil applies the NotNil predicate on the "action_label" field.
func ActionLabelNotNil() predicate.SopNode {
	return predicate.SopNode(sql.FieldNotNull(FieldActionLabel))
}

// HasSopStage applies the HasEdge predicate on the "sop_stage" edge.
func HasSopStage() predicate.SopNode {
	return predicate.SopNode(func(s *sql.Selector) {
		step := sqlgraph.NewStep(
			sqlgraph.From(Table, FieldID),
			sqlgraph.Edge(sqlgraph.M2O, true, SopStageTable, SopStageColumn),
		)
		sqlgraph.HasNeighbors(s, step)
	})
}

// HasSopStageWith applies the HasEdge predicate on the "sop_stage" edge with a given conditions (other predicates).
func HasSopStageWith(preds ...predicate.SopStage) predicate.SopNode {
	return predicate.SopNode(func(s *sql.Selector) {
		step := newSopStageStep()
		sqlgraph.HasNeighborsWith(s, step, func(s *sql.Selector) {
			for _, p := range preds {
				p(s)
			}
		})
	})
}

// HasNodeMessages applies the HasEdge predicate on the "node_messages" edge.
func HasNodeMessages() predicate.SopNode {
	return predicate.SopNode(func(s *sql.Selector) {
		step := sqlgraph.NewStep(
			sqlgraph.From(Table, FieldID),
			sqlgraph.Edge(sqlgraph.O2M, false, NodeMessagesTable, NodeMessagesColumn),
		)
		sqlgraph.HasNeighbors(s, step)
	})
}

// HasNodeMessagesWith applies the HasEdge predicate on the "node_messages" edge with a given conditions (other predicates).
func HasNodeMessagesWith(preds ...predicate.MessageRecords) predicate.SopNode {
	return predicate.SopNode(func(s *sql.Selector) {
		step := newNodeMessagesStep()
		sqlgraph.HasNeighborsWith(s, step, func(s *sql.Selector) {
			for _, p := range preds {
				p(s)
			}
		})
	})
}

// And groups predicates with the AND operator between them.
func And(predicates ...predicate.SopNode) predicate.SopNode {
	return predicate.SopNode(sql.AndPredicates(predicates...))
}

// Or groups predicates with the OR operator between them.
func Or(predicates ...predicate.SopNode) predicate.SopNode {
	return predicate.SopNode(sql.OrPredicates(predicates...))
}

// Not applies the not operator on the given predicate.
func Not(p predicate.SopNode) predicate.SopNode {
	return predicate.SopNode(sql.NotPredicates(p))
}
