// Code generated by ent, DO NOT EDIT.

package soptask

import (
	"time"
	"wechat-api/ent/predicate"

	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
)

// ID filters vertices based on their ID field.
func ID(id uint64) predicate.SopTask {
	return predicate.SopTask(sql.FieldEQ(FieldID, id))
}

// IDEQ applies the EQ predicate on the ID field.
func IDEQ(id uint64) predicate.SopTask {
	return predicate.SopTask(sql.FieldEQ(FieldID, id))
}

// IDNEQ applies the NEQ predicate on the ID field.
func IDNEQ(id uint64) predicate.SopTask {
	return predicate.SopTask(sql.FieldNEQ(FieldID, id))
}

// IDIn applies the In predicate on the ID field.
func IDIn(ids ...uint64) predicate.SopTask {
	return predicate.SopTask(sql.FieldIn(FieldID, ids...))
}

// IDNotIn applies the NotIn predicate on the ID field.
func IDNotIn(ids ...uint64) predicate.SopTask {
	return predicate.SopTask(sql.FieldNotIn(FieldID, ids...))
}

// IDGT applies the GT predicate on the ID field.
func IDGT(id uint64) predicate.SopTask {
	return predicate.SopTask(sql.FieldGT(FieldID, id))
}

// IDGTE applies the GTE predicate on the ID field.
func IDGTE(id uint64) predicate.SopTask {
	return predicate.SopTask(sql.FieldGTE(FieldID, id))
}

// IDLT applies the LT predicate on the ID field.
func IDLT(id uint64) predicate.SopTask {
	return predicate.SopTask(sql.FieldLT(FieldID, id))
}

// IDLTE applies the LTE predicate on the ID field.
func IDLTE(id uint64) predicate.SopTask {
	return predicate.SopTask(sql.FieldLTE(FieldID, id))
}

// CreatedAt applies equality check predicate on the "created_at" field. It's identical to CreatedAtEQ.
func CreatedAt(v time.Time) predicate.SopTask {
	return predicate.SopTask(sql.FieldEQ(FieldCreatedAt, v))
}

// UpdatedAt applies equality check predicate on the "updated_at" field. It's identical to UpdatedAtEQ.
func UpdatedAt(v time.Time) predicate.SopTask {
	return predicate.SopTask(sql.FieldEQ(FieldUpdatedAt, v))
}

// Status applies equality check predicate on the "status" field. It's identical to StatusEQ.
func Status(v uint8) predicate.SopTask {
	return predicate.SopTask(sql.FieldEQ(FieldStatus, v))
}

// DeletedAt applies equality check predicate on the "deleted_at" field. It's identical to DeletedAtEQ.
func DeletedAt(v time.Time) predicate.SopTask {
	return predicate.SopTask(sql.FieldEQ(FieldDeletedAt, v))
}

// Name applies equality check predicate on the "name" field. It's identical to NameEQ.
func Name(v string) predicate.SopTask {
	return predicate.SopTask(sql.FieldEQ(FieldName, v))
}

// Type applies equality check predicate on the "type" field. It's identical to TypeEQ.
func Type(v int) predicate.SopTask {
	return predicate.SopTask(sql.FieldEQ(FieldType, v))
}

// PlanStartTime applies equality check predicate on the "plan_start_time" field. It's identical to PlanStartTimeEQ.
func PlanStartTime(v time.Time) predicate.SopTask {
	return predicate.SopTask(sql.FieldEQ(FieldPlanStartTime, v))
}

// PlanEndTime applies equality check predicate on the "plan_end_time" field. It's identical to PlanEndTimeEQ.
func PlanEndTime(v time.Time) predicate.SopTask {
	return predicate.SopTask(sql.FieldEQ(FieldPlanEndTime, v))
}

// CreatorID applies equality check predicate on the "creator_id" field. It's identical to CreatorIDEQ.
func CreatorID(v string) predicate.SopTask {
	return predicate.SopTask(sql.FieldEQ(FieldCreatorID, v))
}

// CreatedAtEQ applies the EQ predicate on the "created_at" field.
func CreatedAtEQ(v time.Time) predicate.SopTask {
	return predicate.SopTask(sql.FieldEQ(FieldCreatedAt, v))
}

// CreatedAtNEQ applies the NEQ predicate on the "created_at" field.
func CreatedAtNEQ(v time.Time) predicate.SopTask {
	return predicate.SopTask(sql.FieldNEQ(FieldCreatedAt, v))
}

// CreatedAtIn applies the In predicate on the "created_at" field.
func CreatedAtIn(vs ...time.Time) predicate.SopTask {
	return predicate.SopTask(sql.FieldIn(FieldCreatedAt, vs...))
}

// CreatedAtNotIn applies the NotIn predicate on the "created_at" field.
func CreatedAtNotIn(vs ...time.Time) predicate.SopTask {
	return predicate.SopTask(sql.FieldNotIn(FieldCreatedAt, vs...))
}

// CreatedAtGT applies the GT predicate on the "created_at" field.
func CreatedAtGT(v time.Time) predicate.SopTask {
	return predicate.SopTask(sql.FieldGT(FieldCreatedAt, v))
}

// CreatedAtGTE applies the GTE predicate on the "created_at" field.
func CreatedAtGTE(v time.Time) predicate.SopTask {
	return predicate.SopTask(sql.FieldGTE(FieldCreatedAt, v))
}

// CreatedAtLT applies the LT predicate on the "created_at" field.
func CreatedAtLT(v time.Time) predicate.SopTask {
	return predicate.SopTask(sql.FieldLT(FieldCreatedAt, v))
}

// CreatedAtLTE applies the LTE predicate on the "created_at" field.
func CreatedAtLTE(v time.Time) predicate.SopTask {
	return predicate.SopTask(sql.FieldLTE(FieldCreatedAt, v))
}

// UpdatedAtEQ applies the EQ predicate on the "updated_at" field.
func UpdatedAtEQ(v time.Time) predicate.SopTask {
	return predicate.SopTask(sql.FieldEQ(FieldUpdatedAt, v))
}

// UpdatedAtNEQ applies the NEQ predicate on the "updated_at" field.
func UpdatedAtNEQ(v time.Time) predicate.SopTask {
	return predicate.SopTask(sql.FieldNEQ(FieldUpdatedAt, v))
}

// UpdatedAtIn applies the In predicate on the "updated_at" field.
func UpdatedAtIn(vs ...time.Time) predicate.SopTask {
	return predicate.SopTask(sql.FieldIn(FieldUpdatedAt, vs...))
}

// UpdatedAtNotIn applies the NotIn predicate on the "updated_at" field.
func UpdatedAtNotIn(vs ...time.Time) predicate.SopTask {
	return predicate.SopTask(sql.FieldNotIn(FieldUpdatedAt, vs...))
}

// UpdatedAtGT applies the GT predicate on the "updated_at" field.
func UpdatedAtGT(v time.Time) predicate.SopTask {
	return predicate.SopTask(sql.FieldGT(FieldUpdatedAt, v))
}

// UpdatedAtGTE applies the GTE predicate on the "updated_at" field.
func UpdatedAtGTE(v time.Time) predicate.SopTask {
	return predicate.SopTask(sql.FieldGTE(FieldUpdatedAt, v))
}

// UpdatedAtLT applies the LT predicate on the "updated_at" field.
func UpdatedAtLT(v time.Time) predicate.SopTask {
	return predicate.SopTask(sql.FieldLT(FieldUpdatedAt, v))
}

// UpdatedAtLTE applies the LTE predicate on the "updated_at" field.
func UpdatedAtLTE(v time.Time) predicate.SopTask {
	return predicate.SopTask(sql.FieldLTE(FieldUpdatedAt, v))
}

// StatusEQ applies the EQ predicate on the "status" field.
func StatusEQ(v uint8) predicate.SopTask {
	return predicate.SopTask(sql.FieldEQ(FieldStatus, v))
}

// StatusNEQ applies the NEQ predicate on the "status" field.
func StatusNEQ(v uint8) predicate.SopTask {
	return predicate.SopTask(sql.FieldNEQ(FieldStatus, v))
}

// StatusIn applies the In predicate on the "status" field.
func StatusIn(vs ...uint8) predicate.SopTask {
	return predicate.SopTask(sql.FieldIn(FieldStatus, vs...))
}

// StatusNotIn applies the NotIn predicate on the "status" field.
func StatusNotIn(vs ...uint8) predicate.SopTask {
	return predicate.SopTask(sql.FieldNotIn(FieldStatus, vs...))
}

// StatusGT applies the GT predicate on the "status" field.
func StatusGT(v uint8) predicate.SopTask {
	return predicate.SopTask(sql.FieldGT(FieldStatus, v))
}

// StatusGTE applies the GTE predicate on the "status" field.
func StatusGTE(v uint8) predicate.SopTask {
	return predicate.SopTask(sql.FieldGTE(FieldStatus, v))
}

// StatusLT applies the LT predicate on the "status" field.
func StatusLT(v uint8) predicate.SopTask {
	return predicate.SopTask(sql.FieldLT(FieldStatus, v))
}

// StatusLTE applies the LTE predicate on the "status" field.
func StatusLTE(v uint8) predicate.SopTask {
	return predicate.SopTask(sql.FieldLTE(FieldStatus, v))
}

// StatusIsNil applies the IsNil predicate on the "status" field.
func StatusIsNil() predicate.SopTask {
	return predicate.SopTask(sql.FieldIsNull(FieldStatus))
}

// StatusNotNil applies the NotNil predicate on the "status" field.
func StatusNotNil() predicate.SopTask {
	return predicate.SopTask(sql.FieldNotNull(FieldStatus))
}

// DeletedAtEQ applies the EQ predicate on the "deleted_at" field.
func DeletedAtEQ(v time.Time) predicate.SopTask {
	return predicate.SopTask(sql.FieldEQ(FieldDeletedAt, v))
}

// DeletedAtNEQ applies the NEQ predicate on the "deleted_at" field.
func DeletedAtNEQ(v time.Time) predicate.SopTask {
	return predicate.SopTask(sql.FieldNEQ(FieldDeletedAt, v))
}

// DeletedAtIn applies the In predicate on the "deleted_at" field.
func DeletedAtIn(vs ...time.Time) predicate.SopTask {
	return predicate.SopTask(sql.FieldIn(FieldDeletedAt, vs...))
}

// DeletedAtNotIn applies the NotIn predicate on the "deleted_at" field.
func DeletedAtNotIn(vs ...time.Time) predicate.SopTask {
	return predicate.SopTask(sql.FieldNotIn(FieldDeletedAt, vs...))
}

// DeletedAtGT applies the GT predicate on the "deleted_at" field.
func DeletedAtGT(v time.Time) predicate.SopTask {
	return predicate.SopTask(sql.FieldGT(FieldDeletedAt, v))
}

// DeletedAtGTE applies the GTE predicate on the "deleted_at" field.
func DeletedAtGTE(v time.Time) predicate.SopTask {
	return predicate.SopTask(sql.FieldGTE(FieldDeletedAt, v))
}

// DeletedAtLT applies the LT predicate on the "deleted_at" field.
func DeletedAtLT(v time.Time) predicate.SopTask {
	return predicate.SopTask(sql.FieldLT(FieldDeletedAt, v))
}

// DeletedAtLTE applies the LTE predicate on the "deleted_at" field.
func DeletedAtLTE(v time.Time) predicate.SopTask {
	return predicate.SopTask(sql.FieldLTE(FieldDeletedAt, v))
}

// DeletedAtIsNil applies the IsNil predicate on the "deleted_at" field.
func DeletedAtIsNil() predicate.SopTask {
	return predicate.SopTask(sql.FieldIsNull(FieldDeletedAt))
}

// DeletedAtNotNil applies the NotNil predicate on the "deleted_at" field.
func DeletedAtNotNil() predicate.SopTask {
	return predicate.SopTask(sql.FieldNotNull(FieldDeletedAt))
}

// NameEQ applies the EQ predicate on the "name" field.
func NameEQ(v string) predicate.SopTask {
	return predicate.SopTask(sql.FieldEQ(FieldName, v))
}

// NameNEQ applies the NEQ predicate on the "name" field.
func NameNEQ(v string) predicate.SopTask {
	return predicate.SopTask(sql.FieldNEQ(FieldName, v))
}

// NameIn applies the In predicate on the "name" field.
func NameIn(vs ...string) predicate.SopTask {
	return predicate.SopTask(sql.FieldIn(FieldName, vs...))
}

// NameNotIn applies the NotIn predicate on the "name" field.
func NameNotIn(vs ...string) predicate.SopTask {
	return predicate.SopTask(sql.FieldNotIn(FieldName, vs...))
}

// NameGT applies the GT predicate on the "name" field.
func NameGT(v string) predicate.SopTask {
	return predicate.SopTask(sql.FieldGT(FieldName, v))
}

// NameGTE applies the GTE predicate on the "name" field.
func NameGTE(v string) predicate.SopTask {
	return predicate.SopTask(sql.FieldGTE(FieldName, v))
}

// NameLT applies the LT predicate on the "name" field.
func NameLT(v string) predicate.SopTask {
	return predicate.SopTask(sql.FieldLT(FieldName, v))
}

// NameLTE applies the LTE predicate on the "name" field.
func NameLTE(v string) predicate.SopTask {
	return predicate.SopTask(sql.FieldLTE(FieldName, v))
}

// NameContains applies the Contains predicate on the "name" field.
func NameContains(v string) predicate.SopTask {
	return predicate.SopTask(sql.FieldContains(FieldName, v))
}

// NameHasPrefix applies the HasPrefix predicate on the "name" field.
func NameHasPrefix(v string) predicate.SopTask {
	return predicate.SopTask(sql.FieldHasPrefix(FieldName, v))
}

// NameHasSuffix applies the HasSuffix predicate on the "name" field.
func NameHasSuffix(v string) predicate.SopTask {
	return predicate.SopTask(sql.FieldHasSuffix(FieldName, v))
}

// NameEqualFold applies the EqualFold predicate on the "name" field.
func NameEqualFold(v string) predicate.SopTask {
	return predicate.SopTask(sql.FieldEqualFold(FieldName, v))
}

// NameContainsFold applies the ContainsFold predicate on the "name" field.
func NameContainsFold(v string) predicate.SopTask {
	return predicate.SopTask(sql.FieldContainsFold(FieldName, v))
}

// BotWxidListIsNil applies the IsNil predicate on the "bot_wxid_list" field.
func BotWxidListIsNil() predicate.SopTask {
	return predicate.SopTask(sql.FieldIsNull(FieldBotWxidList))
}

// BotWxidListNotNil applies the NotNil predicate on the "bot_wxid_list" field.
func BotWxidListNotNil() predicate.SopTask {
	return predicate.SopTask(sql.FieldNotNull(FieldBotWxidList))
}

// TypeEQ applies the EQ predicate on the "type" field.
func TypeEQ(v int) predicate.SopTask {
	return predicate.SopTask(sql.FieldEQ(FieldType, v))
}

// TypeNEQ applies the NEQ predicate on the "type" field.
func TypeNEQ(v int) predicate.SopTask {
	return predicate.SopTask(sql.FieldNEQ(FieldType, v))
}

// TypeIn applies the In predicate on the "type" field.
func TypeIn(vs ...int) predicate.SopTask {
	return predicate.SopTask(sql.FieldIn(FieldType, vs...))
}

// TypeNotIn applies the NotIn predicate on the "type" field.
func TypeNotIn(vs ...int) predicate.SopTask {
	return predicate.SopTask(sql.FieldNotIn(FieldType, vs...))
}

// TypeGT applies the GT predicate on the "type" field.
func TypeGT(v int) predicate.SopTask {
	return predicate.SopTask(sql.FieldGT(FieldType, v))
}

// TypeGTE applies the GTE predicate on the "type" field.
func TypeGTE(v int) predicate.SopTask {
	return predicate.SopTask(sql.FieldGTE(FieldType, v))
}

// TypeLT applies the LT predicate on the "type" field.
func TypeLT(v int) predicate.SopTask {
	return predicate.SopTask(sql.FieldLT(FieldType, v))
}

// TypeLTE applies the LTE predicate on the "type" field.
func TypeLTE(v int) predicate.SopTask {
	return predicate.SopTask(sql.FieldLTE(FieldType, v))
}

// PlanStartTimeEQ applies the EQ predicate on the "plan_start_time" field.
func PlanStartTimeEQ(v time.Time) predicate.SopTask {
	return predicate.SopTask(sql.FieldEQ(FieldPlanStartTime, v))
}

// PlanStartTimeNEQ applies the NEQ predicate on the "plan_start_time" field.
func PlanStartTimeNEQ(v time.Time) predicate.SopTask {
	return predicate.SopTask(sql.FieldNEQ(FieldPlanStartTime, v))
}

// PlanStartTimeIn applies the In predicate on the "plan_start_time" field.
func PlanStartTimeIn(vs ...time.Time) predicate.SopTask {
	return predicate.SopTask(sql.FieldIn(FieldPlanStartTime, vs...))
}

// PlanStartTimeNotIn applies the NotIn predicate on the "plan_start_time" field.
func PlanStartTimeNotIn(vs ...time.Time) predicate.SopTask {
	return predicate.SopTask(sql.FieldNotIn(FieldPlanStartTime, vs...))
}

// PlanStartTimeGT applies the GT predicate on the "plan_start_time" field.
func PlanStartTimeGT(v time.Time) predicate.SopTask {
	return predicate.SopTask(sql.FieldGT(FieldPlanStartTime, v))
}

// PlanStartTimeGTE applies the GTE predicate on the "plan_start_time" field.
func PlanStartTimeGTE(v time.Time) predicate.SopTask {
	return predicate.SopTask(sql.FieldGTE(FieldPlanStartTime, v))
}

// PlanStartTimeLT applies the LT predicate on the "plan_start_time" field.
func PlanStartTimeLT(v time.Time) predicate.SopTask {
	return predicate.SopTask(sql.FieldLT(FieldPlanStartTime, v))
}

// PlanStartTimeLTE applies the LTE predicate on the "plan_start_time" field.
func PlanStartTimeLTE(v time.Time) predicate.SopTask {
	return predicate.SopTask(sql.FieldLTE(FieldPlanStartTime, v))
}

// PlanStartTimeIsNil applies the IsNil predicate on the "plan_start_time" field.
func PlanStartTimeIsNil() predicate.SopTask {
	return predicate.SopTask(sql.FieldIsNull(FieldPlanStartTime))
}

// PlanStartTimeNotNil applies the NotNil predicate on the "plan_start_time" field.
func PlanStartTimeNotNil() predicate.SopTask {
	return predicate.SopTask(sql.FieldNotNull(FieldPlanStartTime))
}

// PlanEndTimeEQ applies the EQ predicate on the "plan_end_time" field.
func PlanEndTimeEQ(v time.Time) predicate.SopTask {
	return predicate.SopTask(sql.FieldEQ(FieldPlanEndTime, v))
}

// PlanEndTimeNEQ applies the NEQ predicate on the "plan_end_time" field.
func PlanEndTimeNEQ(v time.Time) predicate.SopTask {
	return predicate.SopTask(sql.FieldNEQ(FieldPlanEndTime, v))
}

// PlanEndTimeIn applies the In predicate on the "plan_end_time" field.
func PlanEndTimeIn(vs ...time.Time) predicate.SopTask {
	return predicate.SopTask(sql.FieldIn(FieldPlanEndTime, vs...))
}

// PlanEndTimeNotIn applies the NotIn predicate on the "plan_end_time" field.
func PlanEndTimeNotIn(vs ...time.Time) predicate.SopTask {
	return predicate.SopTask(sql.FieldNotIn(FieldPlanEndTime, vs...))
}

// PlanEndTimeGT applies the GT predicate on the "plan_end_time" field.
func PlanEndTimeGT(v time.Time) predicate.SopTask {
	return predicate.SopTask(sql.FieldGT(FieldPlanEndTime, v))
}

// PlanEndTimeGTE applies the GTE predicate on the "plan_end_time" field.
func PlanEndTimeGTE(v time.Time) predicate.SopTask {
	return predicate.SopTask(sql.FieldGTE(FieldPlanEndTime, v))
}

// PlanEndTimeLT applies the LT predicate on the "plan_end_time" field.
func PlanEndTimeLT(v time.Time) predicate.SopTask {
	return predicate.SopTask(sql.FieldLT(FieldPlanEndTime, v))
}

// PlanEndTimeLTE applies the LTE predicate on the "plan_end_time" field.
func PlanEndTimeLTE(v time.Time) predicate.SopTask {
	return predicate.SopTask(sql.FieldLTE(FieldPlanEndTime, v))
}

// PlanEndTimeIsNil applies the IsNil predicate on the "plan_end_time" field.
func PlanEndTimeIsNil() predicate.SopTask {
	return predicate.SopTask(sql.FieldIsNull(FieldPlanEndTime))
}

// PlanEndTimeNotNil applies the NotNil predicate on the "plan_end_time" field.
func PlanEndTimeNotNil() predicate.SopTask {
	return predicate.SopTask(sql.FieldNotNull(FieldPlanEndTime))
}

// CreatorIDEQ applies the EQ predicate on the "creator_id" field.
func CreatorIDEQ(v string) predicate.SopTask {
	return predicate.SopTask(sql.FieldEQ(FieldCreatorID, v))
}

// CreatorIDNEQ applies the NEQ predicate on the "creator_id" field.
func CreatorIDNEQ(v string) predicate.SopTask {
	return predicate.SopTask(sql.FieldNEQ(FieldCreatorID, v))
}

// CreatorIDIn applies the In predicate on the "creator_id" field.
func CreatorIDIn(vs ...string) predicate.SopTask {
	return predicate.SopTask(sql.FieldIn(FieldCreatorID, vs...))
}

// CreatorIDNotIn applies the NotIn predicate on the "creator_id" field.
func CreatorIDNotIn(vs ...string) predicate.SopTask {
	return predicate.SopTask(sql.FieldNotIn(FieldCreatorID, vs...))
}

// CreatorIDGT applies the GT predicate on the "creator_id" field.
func CreatorIDGT(v string) predicate.SopTask {
	return predicate.SopTask(sql.FieldGT(FieldCreatorID, v))
}

// CreatorIDGTE applies the GTE predicate on the "creator_id" field.
func CreatorIDGTE(v string) predicate.SopTask {
	return predicate.SopTask(sql.FieldGTE(FieldCreatorID, v))
}

// CreatorIDLT applies the LT predicate on the "creator_id" field.
func CreatorIDLT(v string) predicate.SopTask {
	return predicate.SopTask(sql.FieldLT(FieldCreatorID, v))
}

// CreatorIDLTE applies the LTE predicate on the "creator_id" field.
func CreatorIDLTE(v string) predicate.SopTask {
	return predicate.SopTask(sql.FieldLTE(FieldCreatorID, v))
}

// CreatorIDContains applies the Contains predicate on the "creator_id" field.
func CreatorIDContains(v string) predicate.SopTask {
	return predicate.SopTask(sql.FieldContains(FieldCreatorID, v))
}

// CreatorIDHasPrefix applies the HasPrefix predicate on the "creator_id" field.
func CreatorIDHasPrefix(v string) predicate.SopTask {
	return predicate.SopTask(sql.FieldHasPrefix(FieldCreatorID, v))
}

// CreatorIDHasSuffix applies the HasSuffix predicate on the "creator_id" field.
func CreatorIDHasSuffix(v string) predicate.SopTask {
	return predicate.SopTask(sql.FieldHasSuffix(FieldCreatorID, v))
}

// CreatorIDIsNil applies the IsNil predicate on the "creator_id" field.
func CreatorIDIsNil() predicate.SopTask {
	return predicate.SopTask(sql.FieldIsNull(FieldCreatorID))
}

// CreatorIDNotNil applies the NotNil predicate on the "creator_id" field.
func CreatorIDNotNil() predicate.SopTask {
	return predicate.SopTask(sql.FieldNotNull(FieldCreatorID))
}

// CreatorIDEqualFold applies the EqualFold predicate on the "creator_id" field.
func CreatorIDEqualFold(v string) predicate.SopTask {
	return predicate.SopTask(sql.FieldEqualFold(FieldCreatorID, v))
}

// CreatorIDContainsFold applies the ContainsFold predicate on the "creator_id" field.
func CreatorIDContainsFold(v string) predicate.SopTask {
	return predicate.SopTask(sql.FieldContainsFold(FieldCreatorID, v))
}

// HasTaskStages applies the HasEdge predicate on the "task_stages" edge.
func HasTaskStages() predicate.SopTask {
	return predicate.SopTask(func(s *sql.Selector) {
		step := sqlgraph.NewStep(
			sqlgraph.From(Table, FieldID),
			sqlgraph.Edge(sqlgraph.O2M, false, TaskStagesTable, TaskStagesColumn),
		)
		sqlgraph.HasNeighbors(s, step)
	})
}

// HasTaskStagesWith applies the HasEdge predicate on the "task_stages" edge with a given conditions (other predicates).
func HasTaskStagesWith(preds ...predicate.SopStage) predicate.SopTask {
	return predicate.SopTask(func(s *sql.Selector) {
		step := newTaskStagesStep()
		sqlgraph.HasNeighborsWith(s, step, func(s *sql.Selector) {
			for _, p := range preds {
				p(s)
			}
		})
	})
}

// And groups predicates with the AND operator between them.
func And(predicates ...predicate.SopTask) predicate.SopTask {
	return predicate.SopTask(sql.AndPredicates(predicates...))
}

// Or groups predicates with the OR operator between them.
func Or(predicates ...predicate.SopTask) predicate.SopTask {
	return predicate.SopTask(sql.OrPredicates(predicates...))
}

// Not applies the not operator on the given predicate.
func Not(p predicate.SopTask) predicate.SopTask {
	return predicate.SopTask(sql.NotPredicates(p))
}
