package sop_task

import (
	"net/http"

	"github.com/zeromicro/go-zero/rest/httpx"

	"wechat-api/internal/logic/sop_task"
	"wechat-api/internal/svc"
	"wechat-api/internal/types"
)

// swagger:route post /sop_task/list sop_task GetSopTaskList
//
// Get sop task list | 获取SopTask列表
//
// Get sop task list | 获取SopTask列表
//
// Parameters:
//  + name: body
//    require: true
//    in: body
//    type: SopTaskListReq
//
// Responses:
//  200: SopTaskListResp

func GetSopTaskListHandler(svcCtx *svc.ServiceContext) http.HandlerFunc {
	return func(w http.ResponseWriter, r *http.Request) {
		var req types.SopTaskListReq
		if err := httpx.Parse(r, &req, true); err != nil {
			httpx.ErrorCtx(r.Context(), w, err)
			return
		}

		l := sop_task.NewGetSopTaskListLogic(r.Context(), svcCtx)
		resp, err := l.GetSopTaskList(&req)
		if err != nil {
			httpx.ErrorCtx(r.Context(), w, err)
		} else {
			httpx.OkJsonCtx(r.Context(), w, resp)
		}
	}
}
